connectionRulesManager = {}

--============= default tile type ===============
function connectionRulesManager.adjacentConnectionFromDefaultTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromDefaultTile")
	return true
end

function connectionRulesManager.adjacentConnectionToDefaultTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToDefaultTile")
	return true
end
--===============================================


--============= blocker tile type ===============
function connectionRulesManager.adjacentConnectionFromBlockerTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromBlockerTile")
	return true
end

function connectionRulesManager.adjacentConnectionToBlockerTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToBlockerTile")
	return (from.blockType == BLOCK_TYPE_GHOST)
end
--===============================================


--============= number tile type ===============
function connectionRulesManager.adjacentConnectionFromNumberTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromNumberTile")
	return true
end

function connectionRulesManager.adjacentConnectionToNumberTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToNumberTile")
	return true
end
--===============================================


--============= conrner arrow tile type ===============
function connectionRulesManager.adjacentConnectionFromCornerArrowTile(from, to)	
	--dbg.print("connectionRulesManager.adjacentConnectionFromArrowTile")
	local connected = false
	if (from.blockTypeParam == nil) then
		dbg.print("error in connectionRulesManager:adjacentConnectionFromCornerArrowTile")
		return connected
	end
	local dir = string.sub(from.blockTypeParam, 2, 2)--the second character is needed here
	if (dir == "U") then
		connected = from.yGrid > to.yGrid --the grid is filled from the top down
	elseif (dir == "R") then
		connected = from.xGrid < to.xGrid 
	elseif (dir == "D") then
		connected = from.yGrid < to.yGrid --the grid is filled from the top down
	elseif (dir == "L") then
		connected = from.xGrid > to.xGrid 
	else
		dbg.print("error in connectionRulesManager:adjacentConnectionFromCornerArrowTile")
	end
	return connected
end

function connectionRulesManager.adjacentConnectionToCornerArrowTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToArrowTile")
	local connected = false
	if (to.blockTypeParam == nil) then
		dbg.print("error in connectionRulesManager:adjacentConnectionToCornerArrowTile")
		return connected
	end
	local dir = string.sub(to.blockTypeParam, 1, 1)--the first character is needed here 
	if (dir == "U") then
		connected = from.yGrid > to.yGrid --the grid is filled from the top down
	elseif (dir == "R") then
		connected = from.xGrid < to.xGrid 
	elseif (dir == "D") then
		connected = from.yGrid < to.yGrid --the grid is filled from the top down
	elseif (dir == "L") then
		connected = from.xGrid > to.xGrid 
	else
		dbg.print("error in connectionRulesManager:adjacentConnectionToCornerArrowTile")
	end
	return connected	
end

--===============================================



--============= arrow tile type ===============
function connectionRulesManager.adjacentConnectionFromArrowTile(from, to)	
	--dbg.print("connectionRulesManager.adjacentConnectionFromArrowTile from (" ..from.xGrid ..", " ..from.yGrid ..") to (" ..to.xGrid ..", " ..to.yGrid..")")
	local connected = false
	if (from.blockTypeParam == nil) then
		dbg.print("error in connectionRulesManager:adjacentConnectionFromArrowTile")
		return connected
	end
	--dbg.print("from.blockTypeParam " ..from.blockTypeParam .. " len " ..string.len(from.blockTypeParam))
	
	if(string.len(from.blockTypeParam) > 1) then
		connected = connectionRulesManager.adjacentConnectionFromCornerArrowTile(from, to)
	else
		local dir = string.sub(from.blockTypeParam, 1, 1)
		if (dir == "U") then
			connected = from.yGrid > to.yGrid --the grid is filled from the top down
		elseif (dir == "R") then
			connected = from.xGrid < to.xGrid 
		elseif (dir == "D") then
			connected = from.yGrid < to.yGrid --the grid is filled from the top down
		elseif (dir == "L") then
			connected = from.xGrid > to.xGrid 
		else
			dbg.print("error in connectionRulesManager:adjacentConnectionFromArrowTile")
		end
	end
	return connected
end

function connectionRulesManager.adjacentConnectionToArrowTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToArrowTile from (" ..from.xGrid ..", " ..from.yGrid ..") to (" ..to.xGrid ..", " ..to.yGrid..")")
	local connected = false
	if (to.blockTypeParam == nil) then
		dbg.print("error in connectionRulesManager:adjacentConnectionToArrowTile")
		return connected
	end
	
	--dbg.print("to.blockTypeParam " ..to.blockTypeParam .. " len " ..string.len(to.blockTypeParam))
	
	if(string.len(to.blockTypeParam) > 1) then
		connected = connectionRulesManager.adjacentConnectionToCornerArrowTile(from, to)
	else
		local dir = string.sub(to.blockTypeParam, -1)
		if (dir == "U") then
			connected = from.yGrid > to.yGrid --the grid is filled from the top down
		elseif (dir == "R") then
			connected = from.xGrid < to.xGrid 
		elseif (dir == "D") then
			connected = from.yGrid < to.yGrid --the grid is filled from the top down
		elseif (dir == "L") then
			connected = from.xGrid > to.xGrid 
		else
			dbg.print("error in connectionRulesManager:adjacentConnectionToArrowTile")
		end
	end
	return connected	
end
--===============================================

--============= ghost tile type ===============
function connectionRulesManager.adjacentConnectionFromGhostTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromGhostTile")
	return true
end

function connectionRulesManager.adjacentConnectionToGhostTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToGhostTile")
	return true
end
--===============================================

--============= double tile type ===============
function connectionRulesManager.adjacentConnectionFromDoubleTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromDoubleTile")
	return true
end

function connectionRulesManager.adjacentConnectionToDoubleTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToDoubleTile to.numTransit" ..to.numTransit)
	return (to.numTransit > 0)
end
--===============================================

--============= revealed tile ===================
function connectionRulesManager.adjacentConnectionFromRevealedTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromRevealedTile")
	return true
end

function connectionRulesManager.adjacentConnectionToRevealedTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToRevealedTile")
	return false
end
--===============================================

--blockTypeParam H V

--============= pipe tile type ===================
function connectionRulesManager.adjacentConnectionFromPipeTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionFromPipeTile")
	local connected = false
	if (from.blockTypeParam == "H") then
		connected = (from.yGrid == to.yGrid)
	elseif (from.blockTypeParam == "V") then
		connected = (from.xGrid == to.xGrid)
	else
		dbg.assert(false, "ERROR connectionRulesManager.adjacentConnectionFromPipeTile: unknown blockTypeParam " ..from.blockTypeParam )
	end
	return connected
end

function connectionRulesManager.adjacentConnectionToPipeTile(from, to)
	--dbg.print("connectionRulesManager.adjacentConnectionToPipeTile")
	local connected = false
	if (to.blockTypeParam == "H") then
		connected = (from.yGrid == to.yGrid)
	elseif (to.blockTypeParam == "V") then
		connected = (from.xGrid == to.xGrid)
	else
		dbg.assert(false, "ERROR connectionRulesManager.adjacentConnectionToPipeTile: unknown blockTypeParam " ..to.blockTypeParam )
	end
	return connected
end
--===============================================

function connectionRulesManager:isTileBlockaded(block)
	
	local blockaded = false
	if (block.farmersCount ~= nil ) then --checking blockaded by farmer
		if(block.farmersCount > 0) then
			blockaded = true
		end
	end
	return blockaded 
	
	--search for a farmer in the surrounding tiles	
	--[[
	local x = block.xGrid
	local y = block.yGrid
	--self.gameGrid.blocks[event.block.xGrid - 1 + event.block.yGrid * GRID_WIDTH]
	for i=-1,1 do
		for j=-1,1 do
			if(i ~= 0 or j~= 0) then--else it is the same tile
				if( (x + i < 0) or (x + i >= self.gameGrid.gridWidth) or (y + j) < 0 or (y + j) >= self.gameGrid.gridHeight)  then
					--out of grid
				else
					local nb = self.gameGrid.blocks[ (x + i) + (y + j) * GRID_WIDTH]
					if (nb.blockType == BLOCK_TYPE_FARMER) then
						if (nb.blockTypeParam == "U" ) then
							if (nb.yGrid > block.yGrid) then--y index is from top to bottom (top lower values)
								return true
							end
						elseif (nb.blockTypeParam == "R" ) then
							if (nb.xGrid < block.xGrid) then
								return true
							end
						elseif (nb.blockTypeParam == "D" ) then
							if (nb.yGrid < block.yGrid) then--y index is from top to bottom (top lower values)
								return true
							end							
						elseif (nb.blockTypeParam == "L" ) then
							if (nb.xGrid > block.xGrid) then
								return true
							end
						else
						
						end
					end
				end
			end
		end
	end
	return false
	--]]
end


--============= farmer tile type ===================

function connectionRulesManager.adjacentConnectionFromBlockadedTile(from, to)
	return true
end

function connectionRulesManager.adjacentConnectionToBlockadedTile(from, to)
	return false
end

function connectionRulesManager.adjacentConnectionFromFarmerTile(from, to)
	return true--we can always enter into a farmer tile
end

function connectionRulesManager.adjacentConnectionToFarmerTile(from, to)
	return true--we can always exit from a farmer tile
end
--===============================================


function connectionRulesManager:checkAdjacentBlocksConnection(from, to)
	--dbg.print("connectionRulesManager:checkAdjacentBlocksConnection from (" ..from.xGrid ..", " ..from.yGrid ..") to (" ..to.xGrid ..", " ..to.yGrid ..")")
	local fromConnectionFunction = self.fromRulesTable[from.blockType]
	--if (from.isRevealed) then
	
	if (from.isHidden) then
		fromConnectionFunction = self.adjacentConnectionFromRevealedTile
	elseif (self:isTileBlockaded(from)) then
		fromConnectionFunction = self.adjacentConnectionFromBlockadedTile
	end
	
	local toConnectionFunction = self.toRulesTable[to.blockType]
	--if (to.isRevealed) then
	if (to.isHidden) then
		toConnectionFunction = self.adjacentConnectionToRevealedTile
	elseif (self:isTileBlockaded(to)) then
		toConnectionFunction = self.adjacentConnectionToBlockadedTile
	end
	
	local connected = (fromConnectionFunction(from, to) and toConnectionFunction(from, to))
	if connected then 
		--dbg.print("are topologically connected")
	else
		--dbg.print("are NOT topologically connected")
	end
	return connected 
	
end

--TODO WARNING this function is only a workaround: it should be removed 
--once it is clear how to retrieve the "blockaded" flag from a tile
--i.e. farmerRange.isVisible
function connectionRulesManager:setGrid(gameGrid)
	self.gameGrid = gameGrid
end


connectionRulesManager.fromRulesTable = {}
connectionRulesManager.toRulesTable = {}

connectionRulesManager.fromRulesTable[BLOCK_TYPE_DEFAULT] = connectionRulesManager.adjacentConnectionFromDefaultTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_DEFAULT] = connectionRulesManager.adjacentConnectionToDefaultTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_WALL] = connectionRulesManager.adjacentConnectionFromBlockerTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_WALL] = connectionRulesManager.adjacentConnectionToBlockerTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_ARROW] = connectionRulesManager.adjacentConnectionFromArrowTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_ARROW] = connectionRulesManager.adjacentConnectionToArrowTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_NUM] = connectionRulesManager.adjacentConnectionFromNumberTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_NUM] = connectionRulesManager.adjacentConnectionToNumberTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_GHOST] = connectionRulesManager.adjacentConnectionFromGhostTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_GHOST] = connectionRulesManager.adjacentConnectionToGhostTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_FLIP] = connectionRulesManager.adjacentConnectionFromDoubleTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_FLIP] = connectionRulesManager.adjacentConnectionToDoubleTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_PIPE] = connectionRulesManager.adjacentConnectionFromPipeTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_PIPE] = connectionRulesManager.adjacentConnectionToPipeTile

connectionRulesManager.fromRulesTable[BLOCK_TYPE_FARMER] = connectionRulesManager.adjacentConnectionFromFarmerTile
connectionRulesManager.toRulesTable[BLOCK_TYPE_FARMER] = connectionRulesManager.adjacentConnectionToFarmerTile

