pathRulesManager = {}

--[[
/**
Test if a block connected to the last block in path can be added to the path
@return true if the block can be added (the block must be connected to the last block in the path), false otherwise
*/
--]]

function pathRulesManager:preparePathRules(path)
	self.maxBlockNumberValue = 0
	--local count = table.getn(path)
	--for i= count, 1 do
	for k,pathElement in pairs(path) do
		--number value path rule
		--dbg.print("path element " ..k .. " x " ..pathElement.xGrid .." y " ..pathElement.xGrid )
		if (pathElement.blockType == BLOCK_TYPE_NUM) then
			--dbg.print("path element " ..k .. " number value = " ..pathElement.blockTypeParam)
			if (pathElement.blockTypeParam > self.maxBlockNumberValue) then
				self.maxBlockNumberValue = pathElement.blockTypeParam
			end
		end
	end
	--dbg.print("preparePathRules self.maxBlockNumberValue " ..self.maxBlockNumberValue)
end

function pathRulesManager:testAddBlockToPath(path, block)
	--dbg.print("self.maxBlockNumberValue " ..self.maxBlockNumberValue)
	if(block.blockType == BLOCK_TYPE_NUM) then
		--dbg.print("block " ..block.xGrid ..", " ..block.yGrid .." block.blockTypeParam " ..block.blockTypeParam)
		if (block.blockTypeParam ~= self.maxBlockNumberValue + 1) then
			--dbg.print("block " ..block.xGrid ..", " ..block.yGrid .." can NOT be added to the path")
			return false
		end
	end
	--dbg.print("block " ..block.xGrid ..", " ..block.yGrid .." can be added to the path")
	return true	
end
--[[
function pathRulesManager:testAddBlockToPath(path, block)--TODO this should be optimized!
	dbg.print("pathRulesManager:testAddBlockToPath block " ..block.xGrid..", " ..block.yGrid)
	local maxBlockNumberValue = 0
	local count = table.getn(path)
	for i= count, 1 do
		--number value path rule
		if (path[i].blockType == BLOCK_TYPE_NUM) then
			--dbg.print("path element " ..i .. " number value = " ..path[i].blockTypeParam)
			if (path[i].blockTypeParam > maxBlockNumberValue) then
				maxBlockNumberValue = path[i].blockTypeParam
			end
		end
	end

	--number value path rule
	if(block.blockType == BLOCK_TYPE_NUM) then
		if (block.blockTypeParam ~= maxBlockNumberValue + 1) then
			dbg.print("block " ..block.xGrid ..", " ..block.yGrid .." can NOT be added to the path")
			return false
		end
	end
	dbg.print("block " ..block.xGrid ..", " ..block.yGrid .." can be added to the path")
	return true
end
--]]