
hintSystemTutorial = {}

hintSystemTutorial.id = "S_TUTORIAL_INSTRUCTIONS5"
hintSystemTutorial.STUCK_TUTORIAL_REWIND_THRESHOLD 	= 10
hintSystemTutorial.INACTIVE_PLAYER_TIMER_LENGTH		= 5.0
hintSystemTutorial.NO_NAGGLING_TIMER_LENGTH			= 15.0
hintSystemTutorial.DISMISS_MOVES_COUNT				= 5
hintSystemTutorial.inactivePlayerTimer 				= 0
hintSystemTutorial.noNagglingTimer					= hintSystemTutorial.NO_NAGGLING_TIMER_LENGTH
hintSystemTutorial.movesCounter						= 0



function hintSystemTutorial:onBlockChanged(gameGrid, block)
	self.inactivePlayerTimer = 0
	self.movesCounter = self.movesCounter + 1
	if(self.movesCounter > hintSystemTutorial.DISMISS_MOVES_COUNT)then
		if(self:isActive())then
			self:dismissed()
		end
	end
end

function hintSystemTutorial:resetData()
	dbg.print("hintSystemTutorial:resetDatahintSystemTutorial:resetDatahintSystemTutorial:resetDatahintSystemTutorial:resetData")
	self.inactivePlayerTimer = 0
	self.noNagglingTimer = 0
	self.movesCounter = 0
end

function hintSystemTutorial:dismissed()
	self:resetData()
	if(self:isActive()) then
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function hintSystemTutorial:close()--achieves and dismisses this tutorial
	if(self:isActive()) then
		dbg.print("hintSystemTutorial:close")
		tutorialsManager:savePerformedContextTutorial(self.id)
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function hintSystemTutorial:deactivate()
	self.isActiveFlag = false
end

function hintSystemTutorial:activate()
	self.isActiveFlag = true
end

function hintSystemTutorial:isActive()
	return (self.isActiveFlag == true)
end

function hintSystemTutorial:levelComplete()
	if(self:isActive()) then
		self:dismissed()
	end
end

function hintSystemTutorial:hintUsed(startFromX, startFromY)
	dbg.print("================================")
	dbg.print("hintSystemTutorial:hintUsed")
	if(self:isActive()) then
		self:close()
	else
		tutorialsManager:savePerformedContextTutorial(self.id)
	end
end

function hintSystemTutorial:canceled()
	--dbg.print("hintSystemTutorial:canceled")
	self:resetData()
	self:deactivate()
end

function hintSystemTutorial:hintButtonPressed()

end


function hintSystemTutorial:checkActivateCriteria()
	if(tutorialsManager:getWorldId() == tostring(1) and tonumber(tutorialsManager:getLevelId()) <= 3 ) then
		return false
	end
	local activate = false
	--dbg.print("self.inactivePlayerTimer " ..self.inactivePlayerTimer .." self.noNagglingTimer " ..self.noNagglingTimer)
	--dbg.print("hintSystemTutorial.INACTIVE_PLAYER_TIMER_LENGTH " ..hintSystemTutorial.INACTIVE_PLAYER_TIMER_LENGTH )
	--dbg.print("hintSystemTutorial.NO_NAGGLING_TIMER_LENGTH " ..hintSystemTutorial.NO_NAGGLING_TIMER_LENGTH )
	if(self.inactivePlayerTimer > hintSystemTutorial.INACTIVE_PLAYER_TIMER_LENGTH)then
		if(self.noNagglingTimer > hintSystemTutorial.NO_NAGGLING_TIMER_LENGTH)then
			--if(not tutorialsManager:isAContextTutorialActive())then --this criterion has been removed
			--dbg.print("time threshold exceeded")
			--new condition implementation
			if(not tutorialsManager:isSkipButtonTutorialActive()) then
				--dbg.print("skip button tutorial is not active")
				if(not hintsPurchaseManager:isVisible())then
					--dbg.print("hintsPurchaseManager is not visible")
					activate = true
				else
					--dbg.print("hintsPurchaseManager is visible!!!!!!!!!!!!")
				end
			else
				--dbg.print("skip button tutorial is active")
			end
			--dbg.print("hint tutorial activating")
			--else
				--dbg.print("activate = false!!!!!!!!")
			--end
		end
	end
	return activate
end

function hintSystemTutorial:onBlockRewinded(event)
	self.inactivePlayerTimer = 0
	if(not self:isActive())then
		if (event.gameGrid:getRewindCounter() > hintSystemTutorial.STUCK_TUTORIAL_REWIND_THRESHOLD) then
			if(self:checkActivateCriteria())then
				self.inactivePlayerTimer = 0
				self.noNagglingTimer = 0
				tutorialsManager:contextTutorialScheduleAttempt(self.id)
			end
		end
	end
end

function hintSystemTutorial:update(dt)
	if (not self:isActive()) then
		self.inactivePlayerTimer = self.inactivePlayerTimer + dt
		self.noNagglingTimer = self.noNagglingTimer + dt
		--dbg.print("self.inactivePlayerTimer " ..self.inactivePlayerTimer .." self.noNagglingTimer " ..self.noNagglingTimer)
		if(self:checkActivateCriteria())then
			self.inactivePlayerTimer = 0
			self.noNagglingTimer = 0
			tutorialsManager:contextTutorialScheduleAttempt(self.id)
		else
			--dbg.print("hint tutorial could not activate")
		end
	end
end