
hintSystemUsageTutorial = {}

hintSystemUsageTutorial.id = "S_TUTORIAL_INSTRUCTIONS6"
hintSystemUsageTutorial.NUMBER_OF_CORRECT_MOVES_THRESHOLD = 4
hintSystemUsageTutorial.numberOfCorrectMoves = 0



function hintSystemUsageTutorial:onBlockChanged(gameGrid, block)
	if(self:isActive()) then
		local count = #gameGrid.revealedBlocks
		if(count > 0 ) then
			if( count == 1) then
				dbg.print("self.startFromX  " ..self.startFromX .." self.startFromY " ..self.startFromY )
				dbg.print("gameGrid.revealedBlocks[1].xGrid " ..gameGrid.revealedBlocks[1].xGrid )
				dbg.print("gameGrid.revealedBlocks[1].yGrid " ..gameGrid.revealedBlocks[1].yGrid )
				if(gameGrid.revealedBlocks[1].xGrid == self.startFromX and gameGrid.revealedBlocks[1].yGrid == self.startFromY) then
					self:close()--achieved
				end
			else
				if(gameGrid.revealedBlocks[1].xGrid == self.startFromX and gameGrid.revealedBlocks[1].yGrid == self.startFromY) then
					self.numberOfCorrectMoves = self.numberOfCorrectMoves + 1
					if(self.numberOfCorrectMoves > hintSystemUsageTutorial.NUMBER_OF_CORRECT_MOVES_THRESHOLD) then
						self:close()--achieved
					end
				end
			end
		end
	end
end

function hintSystemUsageTutorial:resetData()
	self.numberOfCorrectMoves = 0
end

function hintSystemUsageTutorial:dismissed()
	self:resetData()
	if(self:isActive()) then
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function hintSystemUsageTutorial:close()--achieves and dismisses this tutorial
	if(self:isActive()) then
		dbg.print("<>><<><><>< hintSystemUsageTutorial:close")
		tutorialsManager:savePerformedContextTutorial(self.id)
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function hintSystemUsageTutorial:deactivate()
	self.isActiveFlag = false
end

function hintSystemUsageTutorial:activate()
	self.isActiveFlag = true
end

function hintSystemUsageTutorial:isActive()
	return (self.isActiveFlag == true)
end

function hintSystemUsageTutorial:levelComplete()
	if(self:isActive()) then
		self:dismissed()
	end
end

function hintSystemUsageTutorial:hintUsed(startFromX, startFromY)
	dbg.print("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
	dbg.print("hintSystemUsageTutorial:hintUsed")
	if(not self:isActive())then
		self.startFromX = startFromX
		self.startFromY = startFromY
		tutorialsManager:contextTutorialScheduleAttempt(self.id)
	end
end

function hintSystemUsageTutorial:canceled()
	--dbg.print("hintSystemUsageTutorial:canceled")
	self:resetData()
	self:deactivate()
end

function hintSystemUsageTutorial:hintButtonPressed()

end


function hintSystemUsageTutorial:onBlockRewinded(event)

end

function hintSystemUsageTutorial:update(dt)

end