
rewindingTutorial = {}

rewindingTutorial.id = "S_TUTORIAL_INSTRUCTIONS4"



function rewindingTutorial:onBlockChanged(gameGrid, block)
	local connectionsCount = 0
	pathRulesManager:preparePathRules(gameGrid.revealedBlocks)
	if (block.xGrid > 0) then
		local to = gameGrid.blocks[block.xGrid - 1 + block.yGrid * GRID_WIDTH]
		--dbg.print("checking left connection")
		if (connectionRulesManager:checkAdjacentBlocksConnection(block, to)) then
			--dbg.print("checking left path rule connection")
			if(pathRulesManager:testAddBlockToPath( gameGrid.revealedBlocks, to)) then
				connectionsCount = connectionsCount + 1
			end
		end
		--dbg.print("left connectionsCount " ..connectionsCount )
	end
	if (block.xGrid < gameGrid.gridWidth - 1) then
		local to = gameGrid.blocks[block.xGrid + 1 + block.yGrid * GRID_WIDTH]
		--dbg.print("checking right connection")
		if (connectionRulesManager:checkAdjacentBlocksConnection(block, to)) then
			--dbg.print("checking right path rule connection")
			if(pathRulesManager:testAddBlockToPath( gameGrid.revealedBlocks, to)) then
				connectionsCount = connectionsCount + 1
			end
		end
		--dbg.print("right connectionsCount " ..connectionsCount )
	end
	
	if (block.yGrid > 0) then
		local to = gameGrid.blocks[block.xGrid + (block.yGrid - 1) * GRID_WIDTH]
		--dbg.print("checking up connection")
		if (connectionRulesManager:checkAdjacentBlocksConnection(block, to)) then
			--dbg.print("checking up path rule connection")
			if(pathRulesManager:testAddBlockToPath( gameGrid.revealedBlocks, to)) then
				connectionsCount = connectionsCount + 1
			end
		end
		--dbg.print("up connectionsCount " ..connectionsCount )
	end
	if (block.yGrid < gameGrid.gridHeight - 1) then
		local to = gameGrid.blocks[block.xGrid + (block.yGrid + 1) * GRID_WIDTH]
		--dbg.print("checking down connection")
		if (connectionRulesManager:checkAdjacentBlocksConnection(block, to)) then
			--dbg.print("checking down path rule connection")
			if(pathRulesManager:testAddBlockToPath( gameGrid.revealedBlocks, to)) then
				connectionsCount = connectionsCount + 1
			end
		end
		--dbg.print("down connectionsCount " ..connectionsCount )
	end
	--TODO add early detection of connectionsCount > 0, now we need to test all of the rules
	--dbg.print("connectionsCount " ..connectionsCount )
	if (connectionsCount == 0) then--tutorials manager can only schedule tutorials, it is another object which has the responsiblity to launch them
		--tutorialsManager:checkTutorialSchedule("S_TUTORIAL_INSTRUCTIONS4")--TODO change this call into "scheduleTutorial"
		if(not self:isActive())then
			tutorialsManager:contextTutorialScheduleAttempt(self.id)
		end
	else
		if (not pathRulesManager:testAddBlockToPath( gameGrid.revealedBlocks, block) ) then
			--self:checkTutorialSchedule("S_TUTORIAL_INSTRUCTIONS4")--TODO change this call into "scheduleTutorial"
			if(not self:isActive())then
				tutorialsManager:contextTutorialScheduleAttempt(self.id)
			end
		end
	end

end

function rewindingTutorial:hintButtonPressed()
	dbg.print("rewindingTutorial:hintButtonPressed")
end

function rewindingTutorial:resetData()

end

function rewindingTutorial:dismissed()
	self:resetData()
	if(self:isActive()) then
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end

function rewindingTutorial:close()--achieves and dismisses this tutorial
	if(self:isActive()) then
		tutorialsManager:savePerformedContextTutorial(self.id)
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end
--[[
function rewindingTutorial:close()
	if(self:isActive()) then
		tutorialsManager:savePerformedContextTutorial()
		self:resetData()
		self:deactivate()
		tutorialsManager:closeCurrentTutorial()
	end
end
--]]

function rewindingTutorial:deactivate()
	self.isActiveFlag = false
end

function rewindingTutorial:activate()
	self.isActiveFlag = true
end

function rewindingTutorial:isActive()
	return (self.isActiveFlag == true)
end

function rewindingTutorial:hintUsed(startFromX, startFromY)

end

function rewindingTutorial:levelComplete()
	
end

function rewindingTutorial:canceled()
	dbg.print("rewindingTutorial:canceled")
	self:resetData()
	self:deactivate()
end

function rewindingTutorial:onBlockRewinded(event)
	if(self:isActive())then
		self:close()
	end
end

function rewindingTutorial:update(dt)
	
end