--[[
/**
Builds the table of all available tutorials.
The keys are the tile type, the valules are the file paths of the lua files
that execute the tutorials.
*/
--]]
g_tutorialsTable = {}

--g_tutorialsTable["tile type ID"] = "lua file path"
g_tutorialsTable[""..BLOCK_TYPE_DEFAULT]		= S_TUTORIAL_INSTRUCTIONS1
g_tutorialsTable[""..BLOCK_TYPE_WALL]			= S_TUTORIAL_INSTRUCTIONS7
g_tutorialsTable[""..BLOCK_TYPE_ARROW]			= S_TUTORIAL_INSTRUCTIONS8
g_tutorialsTable["S_TUTORIAL_INSTRUCTIONS3"] 	= S_TUTORIAL_INSTRUCTIONS3
g_tutorialsTable[""..BLOCK_TYPE_NUM]			= S_TUTORIAL_INSTRUCTIONS9
g_tutorialsTable["S_TUTORIAL_INSTRUCTIONS4"]	= S_TUTORIAL_INSTRUCTIONS4
g_tutorialsTable[""..BLOCK_TYPE_GHOST]			= S_TUTORIAL_INSTRUCTIONS10
g_tutorialsTable["S_TUTORIAL_INSTRUCTIONS5"]	= S_TUTORIAL_INSTRUCTIONS5
g_tutorialsTable[""..BLOCK_TYPE_FLIP]			= S_TUTORIAL_INSTRUCTIONS11
g_tutorialsTable["S_TUTORIAL_INSTRUCTIONS6"] 	= S_TUTORIAL_INSTRUCTIONS6
g_tutorialsTable[""..BLOCK_TYPE_FARMER]			= S_TUTORIAL_INSTRUCTIONS13
g_tutorialsTable[""..BLOCK_TYPE_PIPE]			= S_TUTORIAL_INSTRUCTIONS12
g_tutorialsTable["S_TUTORIAL_INSTRUCTIONS14"] 	= S_TUTORIAL_INSTRUCTIONS14
--g_tutorialsTable["9"] 							= S_TUTORIAL_INSTRUCTIONS9
--g_tutorialsTable["10"] 							= S_TUTORIAL_INSTRUCTIONS10
--g_tutorialsTable["11"] 							= S_TUTORIAL_INSTRUCTIONS11
--g_tutorialsTable["12"] 							= S_TUTORIAL_INSTRUCTIONS12

dofile("Tutorials/DontCrossYourPathTutorial.lua")
dofile("Tutorials/RewindingTutorial.lua")
dofile("Tutorials/HintSystemTutorial.lua")
dofile("Tutorials/HintSystemUsageTutorial.lua")
dofile("Tutorials/SkippingButtonTutorial.lua")

g_contextTutorialsTable = {}
g_contextTutorialsTable["S_TUTORIAL_INSTRUCTIONS3"]		= dontCrossYourPathTutorial
g_contextTutorialsTable["S_TUTORIAL_INSTRUCTIONS4"]		= rewindingTutorial
g_contextTutorialsTable["S_TUTORIAL_INSTRUCTIONS5"]		= hintSystemTutorial
g_contextTutorialsTable["S_TUTORIAL_INSTRUCTIONS6"]		= hintSystemUsageTutorial
g_contextTutorialsTable["S_TUTORIAL_INSTRUCTIONS14"]	= skippingButtonTutorial




--more to add



--[[
g_tutorialsTable["0"] = "Tutorials/tutorial_0.png"
g_tutorialsTable["1"] = "Tutorials/tutorial_1.png"
g_tutorialsTable["2"] = "Tutorials/tutorial_2.png"
--]]
--g_tutorialsTable["2"] = "Tutorials/tutorialTileType_2.lua"
--g_tutorialsTable["3"] = "Tutorials/tutorialTileType_3.lua"
