--

resultScreen = {}
resultScreen_mt = { __index = resultScreen }

function resultScreen.init()
	local instance = {}
	setmetatable( instance, resultScreen_mt)
	return instance
end

function resultScreen:create(parentScene)

	self.scene = parentScene
	
	self.darkenGridBG = director:createRectangle( {
        x=director.displayWidth/2, y=director.displayHeight/2, w=director.displayWidth+2, h=director.displayHeight+2,
        color={0, 0, 0},
	    xAnchor = 0.5, yAnchor = 0.5,
        strokeColor={0, 0, 0},
	    strokeAlpha = 0,	
	    alpha = 0, zOrder = 49
    } )
	self.scene:addChild(self.darkenGridBG)

	dbg.print("resultScreen:createresultScreen:createresultScreen:createresultScreen:createresultScreen:createresultScreen:create")
	self.rootNode = director:createNode()
	self.rootNode.zOrder = 50
	self.rootNode.isVisible = false
	self.rootNode.x = director.displayWidth/2
	self.rootNode.y = director.displayHeight/2
	self.rootNode.xScale = 0
	self.rootNode.yScale = 0
	self.rootNode.rotation=315
	
	self.sparkle1 = director:createSprite({xAnchor=0.5,yAnchor=0.5,xScale=UI_SCALE, yScale=UI_SCALE, source="Assets/UI/DailyGiftSunRaysLarge.png"})
	self.rootNode:addChild(self.sparkle1)

	self.sparkle2 = director:createSprite({xAnchor=0.5,yAnchor=0.5,xScale=UI_SCALE, yScale=UI_SCALE, source="Assets/UI/DailyGiftSunRaysLarge.png"})
	self.rootNode:addChild(self.sparkle2)
	
	self.bg = director:createSprite({xAnchor=0.5,yAnchor=0.5,xScale=UI_SCALE, yScale=UI_SCALE, source="Assets/UI/puzzle_completion_behaviour.png"})
	self.rootNode:addChild(self.bg)
	
	self.wellDoneMessage2 = director:createLabel({
        x=self.bg.w/2, y=600,
        w=director.displayWidth/self.bg.xScale, h=120,
        textXScale=1.8, textYScale=1.8,
        rotation=3,
        xAnchor=0.5, yAnchor=0.5,
        alpha=0,
        text=getString(S_HUD_WELL_DONE_2),
        font=GAME_FONT_TITLE,
        hAlignment="centre", vAlignment="bottom"
    })
	self.wellDoneMessage1 = director:createLabel({
        x=self.bg.w/2, y=720,
        w=director.displayWidth/self.bg.xScale, h=120,
        textXScale=1.8,textYScale=1.8,
        rotation=357,
        xAnchor=0.5,yAnchor=0.5,
        alpha=0,
        text=getString(S_HUD_WELL_DONE_1),
        font=GAME_FONT_TITLE,
        hAlignment="centre", vAlignment="bottom"
    })
	self.bg:addChild(self.wellDoneMessage2)
	self.bg:addChild(self.wellDoneMessage1)
	
	local firstStarSparkle = director:createSprite({xAnchor=0.5,yAnchor=0.5,alpha=0,source="Assets/UI/puzzle_completion_behaviour_glowing_effect.png"})
	local firstStarSprite = director:createSprite({x=234,y=-412 + self.bg.h,xAnchor=0.5,yAnchor=0.5,alpha=0,source="Assets/UI/puzzle_completion_behaviour_star_1.png"})
	firstStarSparkle.x=firstStarSprite.w/2
	firstStarSparkle.y=firstStarSprite.h/2
	firstStarSprite.name = "firstStarSprite"
	self.bg:addChild(firstStarSprite)
	firstStarSprite:addChild(firstStarSparkle)
	self.starSpritesArray = {}
	self.starSparkleArray = {}
	self.starSpritesArray[1] = firstStarSprite
	self.starSparkleArray[1] = firstStarSparkle

	local secondStarSparkle = director:createSprite({xAnchor=0.5,yAnchor=0.5,alpha=0, source="Assets/UI/puzzle_completion_behaviour_glowing_effect.png"})
	local secondStarSprite = director:createSprite({x=382,y=-409 + self.bg.h, xAnchor=0.5,yAnchor=0.5,alpha=0,source="Assets/UI/puzzle_completion_behaviour_star_3.png"})
	secondStarSparkle.x=secondStarSprite.w/2
	secondStarSparkle.y=secondStarSprite.h/2
	secondStarSprite.name = "secondStarSprite"
	self.bg:addChild(secondStarSprite)
	secondStarSprite:addChild(secondStarSparkle)
	self.starSpritesArray[2] = secondStarSprite
	self.starSparkleArray[2] = secondStarSparkle

	local thirdStarSparkle = director:createSprite({xAnchor=0.5,yAnchor=0.5,alpha=0, source="Assets/UI/puzzle_completion_behaviour_glowing_effect.png"})
	local thirdStarSprite = director:createSprite({x=538,y=-412 + self.bg.h, xAnchor=0.5,yAnchor=0.5,alpha=0,source="Assets/UI/puzzle_completion_behaviour_star_2.png"})
	thirdStarSparkle.x=thirdStarSprite.w/2
	thirdStarSparkle.y=thirdStarSprite.h/2
	thirdStarSprite.name = "thirdStarSprite"
	self.bg:addChild(thirdStarSprite)	
	thirdStarSprite:addChild(thirdStarSparkle)
	self.starSpritesArray[3] = thirdStarSprite
	self.starSparkleArray[3] = thirdStarSparkle

	self.next = director:createSprite({xAnchor=0.5,yAnchor=0.5, x=215 * UI_SCALE, y=-180*UI_SCALE,xScale=UI_SCALE, yScale=UI_SCALE, alpha=0, source="Assets/UI/Popup_icon_next_button .png"})
	self.nextText = director:createLabel({
        x=0, y=0,
        w=self.next.w*2,
        xAnchor=1,yAnchor=0,
        alpha=0,
        textXScale=0.5,textYScale=0.5,
        text=getString(S_HUD_NEXT),
        font=GAME_FONT,
        hAlignment="right", vAlignment="middle"
    })
	self.rootNode:addChild(self.next)
	self.next:addChild(self.nextText)
	SpriteButton.addAnimatedButtonToSprite(self.next, "Assets/Audio/SFX_Confirm.raw", DefaultButtonAnimation.new(self.next))
	
	self.prev = director:createSprite({xAnchor=0.5,yAnchor=0.5, x=-210 * UI_SCALE, y=-180*UI_SCALE,xScale=UI_SCALE, yScale=UI_SCALE, alpha=0, source="Assets/UI/Popup_icon_mainmenu.png"})
	self.prevText = director:createLabel({
        x=self.prev.w, y=0,
        w=self.prev.w*2,
        xAnchor=0, yAnchor=0,
        alpha=0,
        textXScale=0.5, textYScale=0.5,
        text=getString(S_HUD_BACK),
        font=GAME_FONT,
        hAlignment="left", vAlignment="middle"
    })
	self.rootNode:addChild(self.prev)
	self.prev:addChild(self.prevText)
	SpriteButton.addAnimatedButtonToSprite(self.prev, "Assets/Audio/SFX_Back.raw", DefaultButtonAnimation.new(self.prev))

	self.fbPanel = director:createSprite({x=0, y=-320 * UI_SCALE, xScale = UI_SCALE / 2.4, yScale = UI_SCALE / 1.5, xAnchor = 0.5, yAnchor = 0.5, alpha=0, source="Assets/UI/play_panel.png"})
	self.fbLabel = director:createLabel({
        textXScale=1.2, textYScale=0.75,
        alpha=0,
        text=getString(S_HUD_SHARE),
        font=GAME_FONT,
        hAlignment="centre", vAlignment="bottom",
        textBorderBottom=60
        })
	self.fbButton = director:createSprite({x=self.fbPanel.w/2, y=176, xScale = 2.4, yScale = 1.5, xAnchor = 0.5, yAnchor = 0.5, alpha=0, source="Assets/UI/facebook_button.png"})
	self.rootNode:addChild(self.fbPanel)
	self.fbPanel:addChild(self.fbLabel)
	self.fbPanel:addChild(self.fbButton)
	SpriteButton.addAnimatedButtonToSprite(self.fbButton, "Assets/Audio/SFX_Confirm.raw", DefaultButtonAnimation.new(self.fbButton))

	parentScene:addChild(self.rootNode)

	system:addEventListener("update", self)
	system:addEventListener("buttonActionPerformed", self)
	system:addEventListener("onLevelCompleteFlashFinished", self)
end

function resultScreen:show(gameScene, numStars, showFB)
--	if not facebook:isAvailable() then
--		showFB = false
--	end
	--dbg.print("------resultScreen:showresultScreen:showresultScreen:showresultScreen:show")
	
	local delayTime = 1.5

	self.locked = true
	self.gameScene = gameScene
	self.rootNode.isVisible = true
	self.fbPanel.isVisible = showFB
	
	-- Disable the facebook button if it's not visible
	if self.fbPanel.isVisible then 
		SpriteButton.enableButton(self.fbButton)
	else
		SpriteButton.disableButton(self.fbButton)
	end

	-- Facebook button only appears on completing chapter for first time, so...
	if showFB then
		self.wellDoneMessage1.text=getString(S_HUD_CHAPTER_DONE_1)
		self.wellDoneMessage2.text=getString(S_HUD_CHAPTER_DONE_2)
		self.wellDoneMessage1.textXScale=1.4
		self.wellDoneMessage1.textYScale=1.4
		self.wellDoneMessage2.textXScale=1.4
		self.wellDoneMessage2.textYScale=1.4
	else
		self.wellDoneMessage1.text=getString(S_HUD_WELL_DONE_1)
		self.wellDoneMessage2.text=getString(S_HUD_WELL_DONE_2)
		self.wellDoneMessage1.textXScale=1.8
		self.wellDoneMessage1.textYScale=1.8
		self.wellDoneMessage2.textXScale=1.8
		self.wellDoneMessage2.textYScale=1.8
	end	
	
	-- Stack up the list of tweens for the well done animation
	tween:to(self.rootNode, { xScale=1 , yScale=1, rotation=360, time=1.5, easing=ease.elasticInOut} )

	for i=1, numStars do
		tween:to(self.starSpritesArray[i], { alpha=1, delay=delayTime, time=0.4 } )
		tween:to(self.starSparkleArray[i], { alpha=1, delay=delayTime+0.2, time=0.2 } )
		tween:to(self.starSparkleArray[i], { alpha=0, delay=delayTime+0.4, time=0.2 } )
		delayTime = delayTime + 0.4
		dbg.print("resultScreen:show - setting up tween for star " .. i .. " of " .. numStars)
	end

	tween:to(self.next, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.prev, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.nextText, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.prevText, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.fbPanel, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.fbLabel, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.fbButton, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.wellDoneMessage1, { alpha=1, delay=delayTime, time=0.5 } )
	tween:to(self.wellDoneMessage2, { alpha=1, delay=delayTime, time=0.5 } )
	
	system:addTimer(self, delayTime, 1, 0)
end

function resultScreen:timer(timer)
	if self.locked then
		self.locked = false
		system:addEventListener("backKey", self)
	end
end

function resultScreen:update(event)

	-- Keep the sparkles behind the well done screen rotating
	self.sparkle1.rotation = self.sparkle1.rotation + 0.1
	self.sparkle2.rotation = self.sparkle2.rotation - 0.1
	
	-- Cycle around when they reach 0 or 360
	if self.sparkle1.rotation > 360 then
		self.sparkle1.rotation = self.sparkle1.rotation - 360
	end
	
	if self.sparkle2.rotation < 0 then
		self.sparkle2.rotation = self.sparkle2.rotation + 360
	end
end

function resultScreen:destroy()
    system:removeEventListener({"buttonActionPerformed", "backKey"}, self)
	SpriteButton.tearDown()
	
	self.starSpritesArray = {}
	self.next = nil
    self.prev = nil
    self.fbButton = nil
	self.sparkle1 = nil
	self.sparkle2 = nil
	self.bg = nil
	self.wellDoneMessage = nil
	self.darkenGridBG = nil	

	system:removeEventListener("update", self)
	system:removeEventListener("onLevelCompleteFlashFinished", self)
	self.rootNode:removeFromParent()
    self.rootNode = nil
end

function resultScreen:DoFacebookPost()
	err = facebook:postToWall(
		getString(S_FACEBOOK_TITLE):gsub("$C", self.gameScene.worldInfo.chapterNumber),
		getString(S_FACEBOOK_MESSAGE),
		"http://www.signaltothestars.com",
		"https://fbcdn-sphotos-b-a.akamaihd.net/hphotos-ak-ash3/578780_494536703902702_777879395_n.png"
	)
	return (err == "")
end

function resultScreen:backKey(event)
	system:sendEvent("backToLevelSelection", {fromGame = true})
end

function resultScreen:buttonActionPerformed(event)
	if self.locked then
		-- Do nothing!
	elseif (event.sprite == self.next) then
		self.locked = true
		self:clearResults()
		system:sendEvent("goToNextLevel")
	elseif (event.sprite == self.prev) then
		self.locked = true
		self:clearResults()
		system:sendEvent("backToLevelSelection", {fromGame = true})
	elseif (event.sprite == self.fbButton and self.fbPanel.isVisible) then
		if self:DoFacebookPost() then
			-- Once we've successfully posted, disable and hide the button
			SpriteButton.disableButton(self.fbButton)
			self.fbPanel.isVisible = false
		end
	end
end

function resultScreen:onLevelCompleteFlashFinished(event)
	tween:to(self.darkenGridBG, { alpha = 0.5, time = 2 })
end

function resultScreen:clearResults()
	tween:to(self.darkenGridBG, { alpha = 0, time = 1 })
	tween:to(self.rootNode, { xScale=0, yScale=0, rotation=360, time=1, easing=ease.elasticInOut} )
end
