--

splashScreen = {}
splashScreen_mt = { __index = splashScreen }

function splashScreen.create()
	local instance = {}
	setmetatable( instance, splashScreen_mt)
	instance.scene = director:createScene()
	instance.scene.name = "Scene: Splash Screen"
	instance.scene:addEventListener( { "setUp" , "tearDown"}, instance)
	return instance
end

function splashScreen:setUp(event)
	
	self.screen = director:createSprite( {
        source = "Assets/UI/mq_splash.jpg",
        x = director.displayCenterX,
        y = director.displayCenterY,
        xAnchor = 0.5,
        yAnchor = 0.5,
        xScale = UI_SCALE,
        yScale = UI_SCALE,
    })
	self.scene:addChild(self.screen)
	
    -- Add a timer to both time out the screen and kick off pre-loading of menu gfx
	system:addTimer( self, 0.5, 6)
	dialogManager:setUp()
end

function splashScreen:timer(event)
    if event.doneIterations == 1 then
        -- Load common and front end artwork while the splash screen is up

		FinishMainLoading()
        LoadCommonAssets()
        LoadFrontEndAssets()
        startPreLoader()


--    elseif event.doneIterations > 1 and
--           event.doneIterations < 6 then

--        preLoadByPhase()

    elseif event.doneIterations == 6 then
	    system:sendEvent("goToMainMenu")

    end
end

function splashScreen:tearDown(event)
	dialogManager:tearDown()
	self.screen:removeFromParent()
	self.screen = nil

    self.scene:releaseResources()

end