--

unlockFullGame = {}
unlockFullGame_mt = { __index = unlockFullGame }

unlockFullGame.waitingForResponseFlag = false
unlockFullGame.restoreCompleteFlag = false
unlockFullGame.transactionStartedFlag = false
unlockFullGame.restoreTransactionStartedFlag = false
unlockFullGame.TRANSACTION_TIMEOUT_DIALOG_ID = -1100
unlockFullGame.DISABLED_ALPHA = 0.2

--TODO tune the TRANSACTION_TIMEOUT!
unlockFullGame.TRANSACTION_TIMEOUT = 60.0 --seconds

unlockFullGame.MAXIMUM_ALLOWED_DT = 0.25

function unlockFullGame.create()

	local instance = {}
	setmetatable( instance, unlockFullGame_mt)
	instance.scene = director:createScene()
	instance.scene.name = "Scene: Unlock Full Game"
	instance.scene:addEventListener( { "setUp" , "tearDown" }, instance)
	return instance
end


function unlockFullGame:setUp(event)
	self.timer = 0.0

	self.WAITING_ANIMATION_LABEL_FRAME_1			= getString(S_IAP_WAITING)
	self.WAITING_ANIMATION_LABEL_FRAME_2			= getString(S_IAP_WAITING) .. "."
	self.WAITING_ANIMATION_LABEL_FRAME_3			= getString(S_IAP_WAITING) .. ".."
	self.WAITING_ANIMATION_LABEL_FRAME_4			= getString(S_IAP_WAITING) .. "..."
	self.waitingAnimationFrames = {self.WAITING_ANIMATION_LABEL_FRAME_1, self.WAITING_ANIMATION_LABEL_FRAME_2, self.WAITING_ANIMATION_LABEL_FRAME_3, self.WAITING_ANIMATION_LABEL_FRAME_4}
	self.waitingAnimationTimer = -1.0
	self.waitingAnimationLoopLength = 1.0

	self.node = director:createNode()
	self.scene:addChild(self.node)

	self.graphicsRootNode = director:createSprite( {
        source = "Assets/UI/upsell_screen_bg.png",
        x = director.displayCenterX,
        y = director.displayCenterY,
        xAnchor = 0.5,
        yAnchor = 0.5,
        xScale = UI_SCALE,
        yScale = UI_SCALE,
		zOrder = 100
    })

	self.node:addChild(self.graphicsRootNode)
	
	self.upsellTextPanel1 = director:createSprite( {
        source = "Assets/UI/upsell_wood_small.png",
        x = 240,
        y = 896,
        xAnchor = 0.5,
        yAnchor = 0.5,
		zOrder = 150
    })

	self.upsellTextPanel2 = director:createSprite( {
        source = "Assets/UI/upsell_wood_small.png",
        x = 240,
        y = 640,
        xAnchor = 0.5,
        yAnchor = 0.5,
		zOrder = 150
    })

	self.upsellTextPanel3 = director:createSprite( {
        source = "Assets/UI/upsell_wood_small.png",
        x = 240,
        y = 384,
        xAnchor = 0.5,
        yAnchor = 0.5,
		zOrder = 150
    })

	self.upsellTextPanel4 = director:createSprite( {
        source = "Assets/UI/playButton.png",
        x = 200,
        y = 160,
        xAnchor = 0.5,
        yAnchor = 0.5,
        xScale = 0.6,
        yScale = 0.6,
		zOrder = 150
    })

	self.upsellTextPanel5 = director:createSprite( {
        source = "Assets/UI/playButton.png",
        x = 580,
        y = 160,
        xAnchor = 0.5,
        yAnchor = 0.5,
        xScale = 0.6,
        yScale = 0.6,
		zOrder = 150
    })

	self.graphicsRootNode:addChild(self.upsellTextPanel1)
	self.graphicsRootNode:addChild(self.upsellTextPanel2)
	self.graphicsRootNode:addChild(self.upsellTextPanel3)
	self.graphicsRootNode:addChild(self.upsellTextPanel4)
	self.graphicsRootNode:addChild(self.upsellTextPanel5)

	self.upsellTextLabel1 = director:createLabel( {
		textXScale = 0.4, textYScale = 0.4,
		zOrder = 200,
		text = getString(S_MENU_MTX_UPSELL1),
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
		hAlignment="centre", vAlignment="middle",
        textBorderLeft = 30, textBorderRight = 40, textBorderTop = 30, textBorderBottom = 34
    })
	
	self.upsellTextLabel2 = director:createLabel( {
		textXScale = 0.4, textYScale = 0.4,
		zOrder = 200,
		text = getString(S_MENU_MTX_UPSELL2),
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
		hAlignment="centre", vAlignment="middle",
        textBorderLeft = 30, textBorderRight = 40, textBorderTop = 30, textBorderBottom = 34
    })

	self.upsellTextLabel3 = director:createLabel( {
		textXScale = 0.4, textYScale = 0.4,
		zOrder = 200,
		text = getString(S_MENU_MTX_UPSELL3),
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
	    hAlignment="centre", vAlignment="middle",
        textBorderLeft = 30, textBorderRight = 40, textBorderTop = 30, textBorderBottom = 34
    })

	self.upsellTextLabelBuy = director:createLabel( {
		x = self.upsellTextPanel4.w / 2,
		y = self.upsellTextPanel4.h / 2 - 8,
		w = self.upsellTextPanel4.w * 1.8,
		h = self.upsellTextPanel4.h,
		rotation = 357,
		xAnchor = 0.5,
		yAnchor = 0.5,
		xScale = 0.8,
		yScale = 0.8,
		zOrder = 200,
		text = getString(S_MENU_MTX_UPSELL_UNLOCK),
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
		hAlignment="centre",
		vAlignment="middle"})

	self.upsellTextLabelNoBuy = director:createLabel( {
		x = self.upsellTextPanel5.w / 2,
		y = self.upsellTextPanel5.h / 2 - 8,
		w = self.upsellTextPanel5.w * 1.5,
		h = self.upsellTextPanel5.h,
		rotation = 357,
		xAnchor = 0.5,
		yAnchor = 0.5,
		xScale = 0.8,
		yScale = 0.8,
		zOrder = 200,
		text = getString(S_MENU_MTX_UPSELL_NOTNOW),
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
		hAlignment="centre",
		vAlignment="middle"})

	self.upsellTextLabelPleaseWait = director:createLabel( {
        x=self.graphicsRootNode.w/2,y=self.graphicsRootNode.h/2,
        w=director.displayWidth/self.graphicsRootNode.xScale, h=director.displayHeight/self.graphicsRootNode.yScale,
		textXScale = 0.6, textYScale = 0.6,
        xAnchor=0.5,yAnchor=0.5,
		zOrder = 300,
		text = "",--getString(S_IAP_WAITING),
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
		isTouchable = false,
		hAlignment="centre", vAlignment="top",
        textBorderTop=10
    })
	
	self.graphicsRootNode:addChild(self.upsellTextLabelPleaseWait)
	
--[[	self.upsellTextLabelProductFormattedPrice = director:createLabel( {
		x = (self.upsellTextPanel4.x + self.upsellTextPanel5.x) * 0.5,
		y = self.upsellTextPanel4.y - 8,
		w = 75,
		h = 185,
		xAnchor = 0.5,
		yAnchor = 0.5,
		xScale = 0.5,
		yScale = 0.5,
		zOrder = 200,
		text = "",
		font = GAME_FONT_TITLE,
        color = GAME_FONT_COLOR,
		isTouchable = false,
		hAlignment="centre",
		vAlignment="middle"})
		
	self.graphicsRootNode:addChild(self.upsellTextLabelProductFormattedPrice)
]]

	self.upsellBuyGlow = director:createSprite( {
		source = "Assets/UI/playButtonGlow2.png",
        x = self.upsellTextPanel4.w / 2 - 8,
        y = self.upsellTextPanel4.h / 2 - 8,
        xAnchor = 0.5,
        yAnchor = 0.5,
        xScale = 1,
        yScale = 1,
		zOrder = 120
	})
	
	self.upsellGlowDelta = -1
	
	self.upsellTextPanel1:addChild(self.upsellTextLabel1)
	self.upsellTextPanel2:addChild(self.upsellTextLabel2)
	self.upsellTextPanel3:addChild(self.upsellTextLabel3)
	self.upsellTextPanel4:addChild(self.upsellTextLabelBuy)
	self.upsellTextPanel5:addChild(self.upsellTextLabelNoBuy)
	self.upsellTextPanel4:addChild(self.upsellBuyGlow)
	SpriteButton.addAnimatedButtonToSprite(self.upsellTextLabelBuy, "Assets/Audio/SFX_Confirm.raw", DefaultButtonLabelAnimation.new(self.upsellTextLabelBuy))
	SpriteButton.addAnimatedButtonToSprite(self.upsellTextLabelNoBuy, "Assets/Audio/SFX_Back.raw", DefaultButtonLabelAnimation.new(self.upsellTextLabelNoBuy))
	--self:updateFormattedPriceLabel()
	self.waitingAnimationTimer = -1.0
	system:addEventListener("update", self)
	system:addEventListener({"buttonActionPerformed", "buttonActionStarted"}, self)
	system:addEventListener({"restoreTransactionStarted", "restoreTransactionEnded", "transactionStarted", "transactionEnded", "purchaseFailed", "purchaseSuccessful", "billingRequestCompleted", "backKey"}, self)
	dialogManager:setUp()
end

function unlockFullGame:billingRequestCompleted(event)
	if(g_isFullGameUnlocked()) then
		--self:purchaseComplete()
		--we should never be here
		dbg.print("unlockFullGame:billingRequestCompleted, full game is unlocked")
	else
		dbg.print("unlockFullGame:billingRequestCompleted, full game is NOT unlocked, proceeding to purchase")
		self.upsellTextLabelNoBuy.isTouchable = true
		self.upsellTextLabelNoBuy.alpha = 1
		dbg.print("unlock full game product id " ..billingManager.UNLOCK_FULL_GAME_PROD_ID)
		self:restoreTransactionEnded()
		g_startProductPurchase(billingManager.UNLOCK_FULL_GAME_PROD_ID)
		--[[
		if(g_startProductPurchase(billingManager.UNLOCK_FULL_GAME_PROD_ID) ~= true) then
			dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_MENU_GC_FAIL), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)
		end
		--]]
	end
end

function unlockFullGame:transactionStarted(event)
	self:purchaseTransactionStarted()
end

function unlockFullGame:transactionEnded(event)
	self:deactivateTimer()
end

function unlockFullGame:purchaseFailed(event)
	dbg.print("unlockFullGame:purchaseFailed")
	self:restoreTransactionEnded()
	self:purchaseTransactionEnded()--it just enables the buttons and deactivate the timer
end

function unlockFullGame:purchaseSuccessful(event)
	dbg.print("unlockFullGame:purchaseSuccessful")
	self:purchaseComplete()
end


--[[
function unlockFullGame:updateFormattedPriceLabel()
	--dbg.print("****************************************")
	--dbg.print("unlockFullGame:updateFormattedPriceLabel")
	--dbg.print(""..dbg.getProcessedCallstack())
	--dbg.print("----------------------------------------")
	
	--local formattedProductPrice = unlockFullGamePurchase:getProductFormattedPrice()
	--if( formattedProductPrice == "" or formattedProductPrice == nil) then
	--	self.upsellTextLabelProductFormattedPrice.text = ""		
	--else
	--	self.upsellTextLabelProductFormattedPrice.text = getString(S_MENU_MTX_UPSELL_PRICE) .. "\n" .. unlockFullGamePurchase:getProductFormattedPrice() .. "!"
	--end
end
--]]

function unlockFullGame:update(event)
	local dt = (event.time - self.timer) * 0.001
	--a trick to workaround the time elapsed when the application is suspended
	if(dt > unlockFullGame.MAXIMUM_ALLOWED_DT)then
		dt = unlockFullGame.MAXIMUM_ALLOWED_DT
	end
	self.timer = event.time
	
	-- Strobe the glow around the unlock button
	self.upsellBuyGlow.alpha = self.upsellBuyGlow.alpha + self.upsellGlowDelta / 60

	if self.upsellBuyGlow.alpha >= 1.0 then

		self.upsellBuyGlow.alpha = 1.0
		self.upsellGlowDelta = -1

	elseif self.upsellBuyGlow.alpha <= 0.5 then

		self.upsellBuyGlow.alpha = 0.5
		self.upsellGlowDelta = 1
	end
	
	if (self.waitingAnimationTimer < 0) then
		
	else
		self:updatePleaseWaitAnimation(dt)
	end
	
end

function unlockFullGame:updatePleaseWaitAnimation(dt)
	self.waitingAnimationTimer = self.waitingAnimationTimer + dt
	--lua array are 1 based hence the + 1 in the end of the following statement	
	local framesCount = #self.waitingAnimationFrames
	local animFrameLength = self.waitingAnimationLoopLength / framesCount
	local waitingAnimationIndex = math.floor(self.waitingAnimationTimer / animFrameLength) 
	--a % b == a - math.floor(a/b)*b
	waitingAnimationIndex = waitingAnimationIndex - math.floor(waitingAnimationIndex / framesCount) * framesCount
	waitingAnimationIndex = waitingAnimationIndex + 1 -- LUA indexes arrays elements from one
	self.upsellTextLabelPleaseWait.text = self.waitingAnimationFrames[waitingAnimationIndex]	
	
	if(self.transactionStartedFlag == true or self.restoreTransactionFlag == true)then
		if (self.waitingAnimationTimer >= unlockFullGame.TRANSACTION_TIMEOUT) then
			dbg.print("timer expired = " ..self.waitingAnimationTimer)
			self.waitingAnimationTimer = 0
			--system:addEventListener("dialog", self)
			self:restoreTransactionEnded()
			self:purchaseTransactionEnded()
		end
	end
end

--[[
function unlockFullGame:dialog(event)
	if(event.id == unlockFullGame.TRANSACTION_TIMEOUT_DIALOG_ID) then
		system:removeEventListener("dialog", self)
		system:sendEvent("onBackToWorldSelect", {fromGame = true})
	else
		--dbg.assert(false,"Unknown dialog id " ..event.id)
	end
end
--]]

function unlockFullGame:restoreTransactionEnded(event)
    if not appStore:blockingTransactions() then
		self.restoreTransactionFlag = false
		SpriteButton.enableButton(self.upsellTextLabelBuy)
		self.upsellTextLabelBuy.isTouchable = true
		self.upsellTextLabelBuy.alpha = 1.0
		self.upsellBuyGlow.isVisible = true
		
		self.upsellTextLabelNoBuy.isTouchable = true
		self.upsellTextLabelNoBuy.alpha = 1.0
		
		self:deactivateTimer()
	end
end


function unlockFullGame:restoreTransactionStarted(event)
    if not appStore:blockingTransactions() then
    	self.restoreTransactionFlag = true
		SpriteButton.disableButton(self.upsellTextLabelBuy)
		self.upsellTextLabelBuy.isTouchable = false
		self.upsellTextLabelBuy.alpha = unlockFullGame.DISABLED_ALPHA
		self.upsellBuyGlow.isVisible = false
		self.upsellTextLabelNoBuy.isTouchable = false
		self.upsellTextLabelNoBuy.alpha = unlockFullGame.DISABLED_ALPHA
		self:activateTimer()
	end
end

function unlockFullGame:activateTimer()
	self.upsellTextLabelPleaseWait.isVisible = true
	self.waitingAnimationTimer = 0
end

function unlockFullGame:deactivateTimer()
    self.upsellTextLabelPleaseWait.isVisible = false
	self.waitingAnimationTimer = -1.0
end

function unlockFullGame:purchaseTransactionStarted()
    if not appStore:blockingTransactions() then
		dbg.print("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<unlockFullGame:transactionStarted")
		self.transactionStartedFlag = true
		SpriteButton.disableButton(self.upsellTextLabelNoBuy)
		self.upsellTextLabelNoBuy.isTouchable = false
		self.upsellTextLabelNoBuy.alpha = unlockFullGame.DISABLED_ALPHA
		
		SpriteButton.disableButton(self.upsellTextLabelBuy)
		self.upsellTextLabelBuy.isTouchable = false
		self.upsellTextLabelBuy.alpha = unlockFullGame.DISABLED_ALPHA
		self.upsellBuyGlow.isVisible = false

		self:activateTimer()
	end
end


function unlockFullGame:purchaseTransactionEnded()
    if not appStore:blockingTransactions() then
		self.transactionStartedFlag = false
		SpriteButton.enableButton(self.upsellTextLabelNoBuy)
		self.upsellTextLabelNoBuy.isTouchable = true
		self.upsellTextLabelNoBuy.alpha = 1.0

		SpriteButton.enableButton(self.upsellTextLabelBuy)
		self.upsellTextLabelBuy.isTouchable = true
		self.upsellTextLabelBuy.alpha = 1.0
		self.upsellBuyGlow.isVisible = true
		self:deactivateTimer()
	end
end

function unlockFullGame:purchaseComplete()
	system:sendEvent("onBackToWorldSelect", {fromGame = true})
end

function unlockFullGame:backKey(event)
	system:sendEvent("onBackToWorldSelect", {fromGame = true})
end

function unlockFullGame:buttonActionPerformed(event)
    local target = event.sprite
	if target == self.upsellTextLabelBuy then
		self.upsellTextLabelNoBuy.isTouchable = true
		self.upsellTextLabelNoBuy.alpha = 1
		--dbg.print("unlock full game product id " ..billingManager.UNLOCK_FULL_GAME_PROD_ID)
		--g_startProductPurchase(billingManager.UNLOCK_FULL_GAME_PROD_ID)
		if(g_isFullGameUnlockPurchaseTestModeEnabled() or 
             appStore:getStorePlatform() == quick.QAppStore.ANDROID_AMAZON_APP_STORE )then
			if(not g_startProductPurchase(billingManager.UNLOCK_FULL_GAME_PROD_ID)) then
				dbg.print("WARNING: unlck product puchase failed")
			else
				dbg.print("INFO: unlck product puchase successfully started")
			end
		else
			dbg.print("unlock full game restore products")
			if(not g_restoreProducts())then
				dbg.print("WARNING: unlck product restore failed")
			else
				dbg.print("INFO: products restore successfully started")
			end			
		end
		
		--[[
		if(appStore:getStorePlatform() ~= quick.QAppStore.BLACKBERRY_APP_WORLD) then
			if(not g_restoreProducts())then
				dbg.print("WARNING: products restore failed")
			end
		else
			g_startProductPurchase(billingManager.UNLOCK_FULL_GAME_PROD_ID)
		end
		--]]
	elseif target == self.upsellTextLabelNoBuy then
		self.upsellTextLabelBuy.isTouchable = true
		self.upsellTextLabelBuy.alpha = 1
		system:sendEvent("onBackToWorldSelect", {fromGame = true})
	end	
end

function unlockFullGame:buttonActionStarted(event)
	
	if (event.sprite == self.upsellTextLabelBuy) then
		self.upsellTextLabelNoBuy.isTouchable = false
	elseif (event.sprite == self.upsellTextLabelNoBuy) then
		self.upsellTextLabelBuy.isTouchable = false
	else
		
	end
	
end

function unlockFullGame:isRestoreRequestActive()
	
end

function unlockFullGame:tearDown(event)
	dialogManager:tearDown()
	self.graphicsRootNode:removeFromParent()
	self.graphicsRootNode = nil
	self.upsellTextPanel1 = nil
	self.upsellTextPanel2 = nil
	self.upsellTextPanel3 = nil
	self.upsellTextPanel4 = nil
	self.upsellTextPanel5 = nil
	self.upsellBuyGlow = nil
	
	system:removeEventListener({"update","buttonActionPerformed", "buttonActionStarted"}, self)
	system:removeEventListener({"restoreTransactionStarted", "restoreTransactionEnded", "transactionStarted", "transactionEnded", "purchaseFailed", "purchaseSuccessful","billingRequestCompleted", "backKey"}, self)
end
