dialogManager = {}
dialogManager.TEXT_SCALE = 0.25
dialogManager.BUTTON_STATE_UP_COLOUR = {r=0,g=255,b=0}

function dialogManager:getButtonDownColour()
	return {r = (255 - dialogManager.BUTTON_STATE_UP_COLOUR.r), g = (255 - dialogManager.BUTTON_STATE_UP_COLOUR.g), b = (255 - dialogManager.BUTTON_STATE_UP_COLOUR.b)}
end

function dialogManager:setUp()
	dbg.print("dialogManager:setUp")
	if not dialogManager:isDialogAvailable() then
		self:createCustomGraphics()
	end
end

function dialogManager:tearDown()
	dbg.print("dialogManager:tearDown")
	if not dialogManager:isDialogAvailable() then
		--self.okButtonLabelSpriteButton = nil
		self.okButtonLabel = nil
		self.playButton = nil
		self.titleLabel = nil
		self.msgLabel = nil
		self.dialogBox = nil
		--self.playGlow = nil
		--SpriteButton.tearDown()--it is safe to call this multiple times
		if(self.darkenGridBG ~= nil)then
			--self.darkenGridBG:removeEventListener("touch")
			self.darkenGridBG:removeFromParent()
			self.darkenGridBG = nil
		end
	end
end

function dialogManager:createCustomGraphics()
	dbg.print("dialogManager:createCustomGraphics")
	--[[
	local atlas = director:createAtlas( "Assets/UI/playButton.png" )
	local playButtonAnim = director:createAnimation( atlas )

	local atlas1 = director:createAtlas( "Assets/UI/playButtonGlow2.png" )
	local playGlowAnim = director:createAnimation( atlas1 )
	--]]
	self.darkenGridBG = director:createRectangle( {
        x=director.displayWidth/2, y=director.displayHeight/2, w=director.displayWidth, h=director.displayHeight,
        color={0, 0, 0},
	    xAnchor = 0.5, yAnchor = 0.5,
        strokeColor={0, 0, 0},
	    strokeAlpha = 0,	
	    alpha = 0.8, zOrder = 1000
    } )

	self.dialogBox = director:createRectangle( {
        x=director.displayWidth/2, y=director.displayHeight/2, w=director.displayWidth * 0.8, h=director.displayHeight * 0.35,
        color={0, 0, 0},
	    xAnchor = 0.5, yAnchor = 0.5,
        strokeColor={0, 0, 0},
	    strokeAlpha = 0,	
	    alpha = 1.0, zOrder = 1
    } )

	self.playButton = director:createRectangle( {
        --x=director.displayWidth/2, y=director.displayHeight/2, w=director.displayWidth, h=director.displayHeight,
		
        x = self.dialogBox.w * 0.5,
        y = 0,
		w = self.dialogBox.w * 0.5,
		h = self.dialogBox.h * 0.25,
		
		xAnchor = 0.5,
        yAnchor = 0.5,
		color={dialogManager.BUTTON_STATE_UP_COLOUR.r, dialogManager.BUTTON_STATE_UP_COLOUR.g, dialogManager.BUTTON_STATE_UP_COLOUR.b},
	    xAnchor = 0.5, yAnchor = 0.0,
        strokeColor={0, 0, 0},
	    strokeAlpha = 0,	
	    alpha = 1.0, zOrder = 1
    } )
	
--[[
	local playButton = director:createSprite( {
        source = playButtonAnim,
        x = self.dialogBox.w * 0.5,
        y = 0,
        xAnchor = 0.5,
        yAnchor = 0.0,
        xScale = UI_SCALE * 0.5,
        yScale = UI_SCALE * 0.5,
		alpha = 1.0
    })
	local playGlow = director:createSprite( {
        source = playGlowAnim,
        x = playButton.w / 2 ,
        y = playButton.h / 2 ,
        xAnchor = 0.5,
        yAnchor = 0.5,
        xScale = 1,
        yScale = 1,
		alpha = 1.0
    })
--]]	
	self.titleLabel = director:createLabel( {
        x = 0,
        y = self.dialogBox.h,
        xAnchor = 0.0,
        yAnchor = 1.0,
		color = GAME_FONT_COLOR,
		font = GAME_FONT,
		text = "title",
		textXScale = dialogManager.TEXT_SCALE,
		textYScale = dialogManager.TEXT_SCALE,
		hAlignment = "left",
		vAlignment = "top",
		alpha = 1.0
    })
	
	self.msgLabel = director:createLabel( {
        x = self.dialogBox.w / 2,
        y = self.dialogBox.h * 0.8,
        xAnchor = 0.5,
        yAnchor = 1.0,
		color = GAME_FONT_COLOR,
		font = GAME_FONT,
		text = "message",
		textXScale = dialogManager.TEXT_SCALE,
		textYScale = dialogManager.TEXT_SCALE,
		hAlignment = "centre",
		vAlignment = "top",
		alpha = 1.0
    })
	
	self.okButtonLabel = director:createLabel( {
        source = self.playAnim,
        x = self.playButton.w / 2,
        y = self.playButton.h / 2,
		w = self.playButton.w,
		h = self.playButton.h,
        xAnchor = 0.5,
        yAnchor = 0.5,
		color = GAME_FONT_COLOR,
		font = GAME_FONT,
		text = getString(S_MENU_OK),
		textXScale = dialogManager.TEXT_SCALE / self.playButton.xScale,
		textYScale = dialogManager.TEXT_SCALE / self.playButton.yScale,
		hAlignment = "centre",
		vAlignment = "middle",
		alpha = 1.0
    })
		
	director:getCurrentScene():addChild(self.darkenGridBG)
	self.darkenGridBG:addChild(self.dialogBox)
	--playButton:addChild(playGlow)
	self.playButton:addChild(self.okButtonLabel)
	
	self.dialogBox:addChild(self.playButton)
	self.dialogBox:addChild(self.titleLabel)
	self.dialogBox:addChild(self.msgLabel)
	
	--self.darkenGridBG:addEventListener({"touch"}, self)
	
	--self.playGlow = playGlow
	--self.okButtonLabelSpriteButton = SpriteButton.addAnimatedButtonToSprite(self.okButtonLabel, "Assets/Audio/SFX_Confirm.raw", DefaultButtonLabelAnimation.new(self.okButtonLabel))
	--SpriteButton.addAnimatedButtonToSprite(playButton, "Assets/Audio/SFX_Confirm.raw", DefaultButtonLabelAnimation.new(playButton))
	dialogManager:disableCustomDialog()
end

function dialogManager:disableCustomDialog()
	self.darkenGridBG.isVisible = false
	self.darkenGridBG.isTouchable = false
end

function dialogManager:enableCustomDialog()
	self.darkenGridBG.isVisible = true
	self.darkenGridBG.isTouchable = true
end

function dialogManager:close()
	system:sendEvent("dialog", {buttonIndex=0, id = self.customDialogsQueue.id})
	self:dequeueOkDialog()
	self:displayNextEnqueuedOkDialog()
end
--[[
function dialogManager:buttonActionPerformed(event)
	if(event.sprite == self.playText) then		
		system:sendEvent("dialog", {buttonIndex=0, id = self.customDialogsQueue.id})
		self:dequeueOkDialog()
		self:displayNextEnqueuedOkDialog()
	end
end
--]]

function dialogManager:touch(event)
	if(self.darkenGridBG ~= nil)then
		if(self.darkenGridBG.isTouchable == true) then
			if (event.phase == "ended" ) then
				self:close()
			end
			--[[
			if(event.phase == "began" or event.phase == "moved")then
				if(self.playButton:isPointInside(event.x,event.y))then
					local col = self:getButtonDownColour()
					self.playButton.color = {col.r, col.g, col.b}
				end
			elseif (event.phase == "ended" ) then
				self.playButton.color = {dialogManager.BUTTON_STATE_UP_COLOUR.r, dialogManager.BUTTON_STATE_UP_COLOUR.g, dialogManager.BUTTON_STATE_UP_COLOUR.b}
				if(self.playButton:isPointInside(event.x,event.y))then
					self:close()
				end
			else
				--unmanaged event phase
			end
			--]]
			dbg.print("returning true....................")
			dbg.print("returning true....................")
			dbg.print("returning true....................")
			dbg.print("returning true....................")
			dbg.print("returning true....................")
			return true
		end
	end
	--return false
end

function dialogManager:isDialogAvailable()
	return cmw.CMWDialog:IsDialogAvailable()
	--return false
end

function dialogManager:displayOkDialog(title, msg, okButtonLabel, id, callback, callbackData)
	if(self:isDialogAvailable()) then
		return cmw.CMWDialog:DisplayOkDialog(title, msg, okButtonLabel, id)
	else
		--this entry point has changed to implement cusotm dialog boxes
		self:enqueueOkDialog(title, msg, okButtonLabel, id)
		return false
	end
end

function dialogManager:displayOkCancelDialog(title, msg, okButtonLabel, cancelButtonLabel, id, callback, callbackData)
	if(self:isDialogAvailable()) then
		return cmw.CMWDialog:DisplayOkCancelDialog(title, msg, okButtonLabel, cancelButtonLabel, id)
	else
		return false
	end
end

function dialogManager:displayNextEnqueuedOkDialog()
	--dbg.print("dialogManager:displayNextEnqueuedOkDialog")
	if(self.customDialogsQueue ~= nil)then
		self:displayCustomOkDialog(self.customDialogsQueue.title, self.customDialogsQueue.msg, self.customDialogsQueue.okButtonLabel, self.customDialogsQueue.id)
	else
		self:disableCustomDialog()
	end
end

function dialogManager:displayCustomOkDialog(title, msg, okButtonLabel, id)
	dbg.print("dialogManager:displayCustomOkDialog")
	self:enableCustomDialog()
	self.msgLabel.text = msg
	self.titleLabel.text = title
end

function dialogManager:dequeueOkDialog()
	if(self.customDialogsQueue ~= nil)then
		self.customDialogsQueue = self.customDialogsQueue.next
	end	
end

function dialogManager:logQueue()
	local currentElement = dialogManager.customDialogsQueue
	local nextElement = currentElement.next
	while(currentElement ~= nil) do
		dbg.print("id dialog enqueued " ..currentElement.id)
		currentElement = currentElement.next
	end	
end

function dialogManager:enqueueOkDialog(title, msg, okButtonLabel, id)
	dbg.print("dialogManager:enqueueOkDialog")
	local newElement = {title = title, msg = msg, okButtonLabel = okButtonLabel, id = id}
	if(self.customDialogsQueue == nil)then
		self.customDialogsQueue = newElement
	else
		local currentElement = dialogManager.customDialogsQueue
		local nextElement = currentElement.next
		while(nextElement ~= nil) do
			currentElement = nextElement
			nextElement = nextElement.next
		end	
		currentElement.next = newElement
	end
	self:logQueue()
end

function dialogManager:update(event)
	if(self.darkenGridBG ~= nil)then
		if(not self.darkenGridBG.isVisible) then			
			dialogManager:displayNextEnqueuedOkDialog()
		end
	end
end

system:addEventListener({ "update", "touch"}, dialogManager)
