DefaultButtonAnimation = {}

DefaultButtonAnimation.ANIMATION_TIMER_LENGTH		= 0.1
DefaultButtonAnimation.SCALE_FACTOR					= 1.1

DefaultButtonAnimation. new = function(sprite)
	local self = {}
	local animationTimer = 0.0
	local originalXScale = sprite.xScale
	local originalYScale = sprite.yScale
	local enabled = true
	
	local glowingSprite = director:createSprite({x=0, y=0, 
							xAnchor=0, yAnchor=0, 
							xScale=1.0, yScale=1.0,
							zOrder=sprite.zOrder+1,
							xFlip = sprite.xFlip,
							yFlip = sprite.yFlip,
							source=sprite.animation,
							alpha = 0.0,
							blendMode = "add"
							})

	sprite:addChild(glowingSprite)

	
	self.animationInUpdate =  function(dt)
		local finished = false
		if(not enabled)then
			finished = true
		else
			animationTimer = animationTimer + dt
			if (animationTimer > DefaultButtonAnimation.ANIMATION_TIMER_LENGTH) then
				animationTimer = DefaultButtonAnimation.ANIMATION_TIMER_LENGTH
				finished = true
			end
			local progress = animationTimer / DefaultButtonAnimation.ANIMATION_TIMER_LENGTH
			glowingSprite.alpha = progress
			progress = 1.0 + progress * (DefaultButtonAnimation.SCALE_FACTOR - 1.0)
			sprite.xScale = originalXScale * progress
			sprite.yScale = originalYScale * progress
		end
		return finished
	end
	
	self.animationOutUpdate = function(dt)
		local finished = false
		if(not enabled)then
			finished = true
		else
			animationTimer = animationTimer - dt
			if (animationTimer < 0.0) then
				animationTimer = 0.0
				finished = true
			end	
			local progress = animationTimer / DefaultButtonAnimation.ANIMATION_TIMER_LENGTH
			glowingSprite.alpha = progress
			progress = 1.0 + progress * (DefaultButtonAnimation.SCALE_FACTOR - 1.0)		
			sprite.xScale = originalXScale * progress
			sprite.yScale = originalYScale * progress
		end
		return finished
	end
	
	
	self.reset = function()
		animationTimer = 0.0
		sprite.xScale = originalXScale
		sprite.yScale = originalYScale
		glowingSprite.alpha = 0.0
	end
	
	self.enable = function()
		enabled = true
	end
	
	self.disable = function()
		enabled = false
		self.reset()
	end

	return self
end