DefaultButtonLabelAnimation = {}

DefaultButtonLabelAnimation.ANIMATION_TIMER_LENGTH		= 0.1
DefaultButtonLabelAnimation.SCALE_FACTOR					= 1.1

DefaultButtonLabelAnimation. new = function(label)
	local self = {}
	local animationTimer = 0.0
	local originalXScale = label.xScale
	local originalYScale = label.yScale
	local origColour = {r=label.color.r, g=label.color.g, b=label.color.b}
	local enabled = true
	
	--[[ -- DISABLED until Quick supports blendmode for labels
		local glowingLabel = director:createLabel({
							x=label.x, y=label.y + 16,
							w=label.w, h=label.h,
							xAnchor=label.xAnchor, yAnchor=label.yAnchor, 
							xScale=label.xScale, yScale=label.yScale,
							zOrder=label.zOrder+1,
							hAlignment = label.hAlignment,
							vAlignment = label.vAlignment,
							color = label.color,
							text = label.text,
							font = label.font,
							alpha = 0.0,
							blendMode = "add"
							})

		if label.parent then
			label.parent:addChild(glowingLabel)
		end
	--]]

	self.animationInUpdate =  function(dt)
		local finished = false
		if(not enabled)then
			finished = true
		else
			animationTimer = animationTimer + dt
			if (animationTimer > DefaultButtonLabelAnimation.ANIMATION_TIMER_LENGTH) then
				animationTimer = DefaultButtonLabelAnimation.ANIMATION_TIMER_LENGTH
				finished = true
			end
			local progress = animationTimer / DefaultButtonLabelAnimation.ANIMATION_TIMER_LENGTH
			label.color.r = origColour.r + progress * (255 - origColour.r)
			label.color.g = origColour.g + progress * (255 - origColour.g)
			label.color.b = origColour.b + progress * (255 - origColour.b)
			progress = 1.0 + progress * (DefaultButtonLabelAnimation.SCALE_FACTOR - 1.0)
			label.xScale = originalXScale * progress
			label.yScale = originalYScale * progress
			--if glowingLabel then
			--	glowingLabel.xScale = label.xScale
			--	glowingLabel.yScale = label.yScale
			--	glowingLabel.alpha = animationTimer / FlashOnlyButtonAnimation.ANIMATION_TIMER_LENGTH
			--end
		end
		return finished
	end
	
	
	self.animationOutUpdate = function(dt)
		local finished = false
		if(not enabled)then
			finished = true
		else
			animationTimer = animationTimer - dt
			if (animationTimer < 0.0) then
				animationTimer = 0.0
				finished = true
			end	
			local progress = animationTimer / DefaultButtonLabelAnimation.ANIMATION_TIMER_LENGTH
			label.color.r = origColour.r - progress * (255 - origColour.r)
			label.color.g = origColour.g - progress * (255 - origColour.g)
			label.color.b = origColour.b - progress * (255 - origColour.b)

			progress = 1.0 + progress * (DefaultButtonLabelAnimation.SCALE_FACTOR - 1.0)		
			label.xScale = originalXScale * progress
			label.yScale = originalYScale * progress
			--if glowingLabel then
			--	glowingLabel.xScale = label.xScale
			--	glowingLabel.yScale = label.yScale
			--	glowingLabel.alpha = animationTimer / FlashOnlyButtonAnimation.ANIMATION_TIMER_LENGTH
			--end
		end
		return finished
	end
	
	
	self.reset = function()
		animationTimer = 0.0
		label.xScale = originalXScale
		label.yScale = originalYScale
		label.color.r = origColour.r
		label.color.g = origColour.g
		label.color.b = origColour.b
		--glowingLabel.alpha = 0.0
	end
	
	self.enable = function()
		enabled = true
	end
	
	self.disable = function()
		enabled = false
		self.reset()
	end
	
	return self
end
