G_BILLING_TEST_MODE = false
G_BILLING_UNLOCK_RESTORE_TEST = false
G_BILLING_UNLOCK_PURCHASE_TEST = false

billingManager = {}

billingManager.DIALOG_BILLING_ERROR_ID = -54320
billingManager.DIALOG_BILLING_RESTORE_ID = -54321
billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID = -54322
billingManager.DIALOG_BILLING_REFUNDED_ID = -54323
billingManager.DIALOG_CONNECTION_ERROR_ID = -54324


billingManager.DEFAULT_HINTS_COUNT 		= 3
billingManager.DEFAULT_FULL_GAME_UNLOCKED = false
billingManager.FULL_GAME_UNLOCKED_STR 	= "1"
billingManager.FULL_GAME_LOCKED_STR 		= "0"


billingManager.hintsCount = billingManager.DEFAULT_HINTS_COUNT
billingManager.fullGameUnlockedFlag = billingManager.DEFAULT_FULL_GAME_UNLOCKED

billingManager.scheduledOkDialogsTable = {}

dbg.print("------------------------------BILLING------------------------------")

if (appStore:getStorePlatform() == quick.QAppStore.ANDROID_GOOGLE_PLAY_STORE) then
	dbg.print("Using Google Play Store product names")

	-- Use lower case versions of the product ids
	billingManager.HINT_PACK_BRONZE_PROD_ID = "hp1"
	billingManager.HINT_PACK_SILVER_PROD_ID = "hp2"
	billingManager.HINT_PACK_GOLD_PROD_ID = "hp3"
	billingManager.UNLOCK_FULL_GAME_PROD_ID = "unlck"

elseif (appStore:getStorePlatform() == quick.QAppStore.BLACKBERRY_APP_WORLD) then
	dbg.print("Using Blackberry World product names")

	billingManager.HINT_PACK_BRONZE_PROD_ID = "23953883"
	billingManager.HINT_PACK_SILVER_PROD_ID = "23974882"
	billingManager.HINT_PACK_GOLD_PROD_ID = "23974885"
	billingManager.UNLOCK_FULL_GAME_PROD_ID = "23953881"

else
	dbg.print("Using standard product names")

	billingManager.HINT_PACK_BRONZE_PROD_ID 	= "HP1";
	billingManager.HINT_PACK_SILVER_PROD_ID 	= "HP2";
	billingManager.HINT_PACK_GOLD_PROD_ID 		= "HP3";
	billingManager.UNLOCK_FULL_GAME_PROD_ID 	= "UNLCK";

end

dbg.print("  Bronze Pack Id: "..billingManager.HINT_PACK_BRONZE_PROD_ID)
dbg.print("  Silver Pack Id: "..billingManager.HINT_PACK_SILVER_PROD_ID)
dbg.print("  Gold Pack Id: "..billingManager.HINT_PACK_GOLD_PROD_ID)
dbg.print("  Full unlock Id: "..billingManager.UNLOCK_FULL_GAME_PROD_ID)

billingManager.hintsQuantityTable = {}
local hqt = billingManager.hintsQuantityTable
hqt[billingManager.HINT_PACK_BRONZE_PROD_ID]	= 10
hqt[billingManager.HINT_PACK_SILVER_PROD_ID]	= 25
hqt[billingManager.HINT_PACK_GOLD_PROD_ID]		= 60

billingManager.productsTitlesStaticMap = {}
local ptsm = billingManager.productsTitlesStaticMap
ptsm[billingManager.HINT_PACK_BRONZE_PROD_ID]	= "Bronze hint package"
ptsm[billingManager.HINT_PACK_SILVER_PROD_ID]	= "Silver hint package"
ptsm[billingManager.HINT_PACK_GOLD_PROD_ID]		= "Gold hint package"
ptsm[billingManager.UNLOCK_FULL_GAME_PROD_ID]	= "Unlock full game"

billingManager.productsTitlesWithBreaksStaticMap = {}
local ptwbsm = billingManager.productsTitlesWithBreaksStaticMap
ptwbsm[billingManager.HINT_PACK_BRONZE_PROD_ID]	= "Bronze\nhint\npackage"
ptwbsm[billingManager.HINT_PACK_SILVER_PROD_ID]	= "Silver\nhint\npackage"
ptwbsm[billingManager.HINT_PACK_GOLD_PROD_ID]	= "Gold\nhint\npackage"


-- Fill the available products info locally on platforms that don't allow us to do lookups
billingManager.availableProductInfosMap = {}
local apim = billingManager.availableProductInfosMap
if not appStore:isQuerySupported() then
	dbg.print("Filling available products info with static data")
	apim[billingManager.HINT_PACK_BRONZE_PROD_ID] =
	{
		title = ptsm[billingManager.HINT_PACK_BRONZE_PROD_ID],
        titlewithbreaks = ptwbsm[billingManager.HINT_PACK_BRONZE_PROD_ID],
		description = "Package of "..hqt[billingManager.HINT_PACK_BRONZE_PROD_ID].." hints"
	}
	apim[billingManager.HINT_PACK_SILVER_PROD_ID] =
	{
		title = ptsm[billingManager.HINT_PACK_SILVER_PROD_ID],
        titlewithbreaks = ptwbsm[billingManager.HINT_PACK_SILVER_PROD_ID],
		description = "Package of "..hqt[billingManager.HINT_PACK_SILVER_PROD_ID].." hints"
	}
	apim[billingManager.HINT_PACK_GOLD_PROD_ID] =
	{
		title = ptsm[billingManager.HINT_PACK_GOLD_PROD_ID],
        titlewithbreaks = ptwbsm[billingManager.HINT_PACK_GOLD_PROD_ID],
		description = "Package of "..hqt[billingManager.HINT_PACK_GOLD_PROD_ID].." hints"
	}
	apim[billingManager.UNLOCK_FULL_GAME_PROD_ID] =
	{
		title = ptsm[billingManager.UNLOCK_FULL_GAME_PROD_ID],
        titlewithbreaks = ptsm[billingManager.UNLOCK_FULL_GAME_PROD_ID],
		description = "Unlock full game"
	}
end

g_billingAvailable = billing:init()

if(g_billingAvailable == true) then
	dbg.print("Billing available test mode = " ..tostring(G_BILLING_TEST_MODE))
	billing:setTestMode(G_BILLING_TEST_MODE)
else
	dbg.print("Billing NOT available")
end

function g_isFullGameUnlockPurchaseTestModeEnabled()
	return G_BILLING_UNLOCK_PURCHASE_TEST
end

function g_enableFullGameUnlockPurchaseTestMode()
	G_BILLING_UNLOCK_PURCHASE_TEST = true
end

function g_isFullGameUnlockRestoreTestEnabled()
	return G_BILLING_UNLOCK_RESTORE_TEST
end

function g_isBillingTestModeEnabled()
	return G_BILLING_TEST_MODE
end

function g_enableBillingTestMode()
	G_BILLING_TEST_MODE = true
	billing:setTestMode(G_BILLING_TEST_MODE)
end

function g_zeroHintsAndSave()
	billingManager:setHintsCount(0)
	g_saveData()
end

function g_enableFullGameUnlockRestoreTest()
	dbg.print("g_enableFullGameUnlockRestoreTest")
	G_BILLING_UNLOCK_RESTORE_TEST = true
	g_enableBillingTestMode()
end

function g_unlockFullGameCheat()
	billingManager:setUnlockFullGameFlag(1)
	dbg.print("g_unlockFullGameCheat done")
end

function g_restoreProducts()
	dbg.print("g_restoreProducts")
	local result = true
	if(g_billingAvailable == false) then
		result = false
	else
		system:sendEvent("restoreTransactionStarted", {})
		billingManager.restoreRequesFlag = true
		result = billing:restoreTransactions()
	end
	if(not result) then
		dbg.print("ERROR g_restoreProducts not started")
		system:sendEvent("restoreTransactionEnded", {})
		--added to manage the lack of dialog box extension on blackberry
		if( not dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_MENU_GC_FAIL), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)) then
			system:sendEvent("purchaseFailed", {})
		end
	end
	return result
end

function billingManager:displayNoNetworkConnectionDialog()

	dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_DISCONNECTED), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)

end

function g_startProductPurchase(productId)
	local result = true
	if(appStore:isNetworkAvailable())then
		if(g_billingAvailable == false) then
			result = false
		else
			billingManager.restoreRequesFlag = false
			system:sendEvent("transactionStarted", {})
			dbg.print("Purchase starting with id "..productId)
			result = billing:purchaseProduct(productId)	
		end
		if(not result) then
			system:sendEvent("transactionEnded", {})
			if( not dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_MENU_GC_FAIL), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)) then
				system:sendEvent("purchaseFailed", {})
				dbg.print("WARNING: start purchase failed")
			end
		end
	else
		result = false
		billingManager:displayNoNetworkConnectionDialog()
	end
	return result
end

function g_isProductInfoDataAvailable(productId)
	return (billingManager.availableProductInfosMap[productId] ~= nil)
end

function g_retrieveProductsInfoData()
	if(g_billingAvailable) then
		dbg.print("g_retrieveProductsInfoData")
		dbg.print("g_retrieveProductsInfoData printing static products table")
		dbg.printTable(billingManager.productsTitlesStaticMap)
		if(billingManager.availableProductInfosMap ~= nil) then
			dbg.print("g_retrieveProductsInfoData printing available products table")
			dbg.printTable(billingManager.availableProductInfosMap)
		end
		for k, value in pairs(billingManager.productsTitlesStaticMap) do
			if (g_isProductInfoDataAvailable(k) == false) then
				dbg.print("querying product " ..k)
				return billing:queryProduct(k)
			else
				dbg.print(k.." product info already available ")
				dbg.printTable(billingManager.availableProductInfosMap[k])
			end
		end
	end
	return true--no errors
end

function g_hintConsumed()
	billingManager.hintsCount = billingManager.hintsCount - 1
	if(billingManager.hintsCount < 0 ) then
		billingManager.hintsCount = 0--we should never be here
	end
	return g_saveData()
end

function g_isFullGameUnlocked()
	return billingManager.fullGameUnlockedFlag
end

function g_getHintsCount()
	return billingManager.hintsCount
end

function g_PurchasableProductsDataLoaded(fullGameUnlockNum , hintsCount)
	dbg.print("g_PurchasableProductsDataLoaded fullGameUnlockNum " ..fullGameUnlockNum  .." hintsCount " ..hintsCount)
	billingManager:setHintsCount(hintsCount)
	billingManager:setUnlockFullGameFlag(fullGameUnlockNum )
end

function billingManager:setHintsCount(hintsCount)
	dbg.print("setHintsCount to " ..hintsCount)
	billingManager.hintsCount = hintsCount
	--note: do not save the hints count here
	system:sendEvent("updateHintsCount", {})
end

function billingManager:setUnlockFullGameFlag(flagNum)
	dbg.print("billingManager:setUnlockFullGameFlag to " ..flagNum)
	if(flagNum ~= 0) then 
		billingManager.fullGameUnlockedFlag = true
	else
		billingManager.fullGameUnlockedFlag = false
	end
	--note: do not save data here
end

function billingManager:clearDialogCallback(dialogId, callback, callbackData)
	if(self.callbackDataTable ~= nil)then
		self.callbackDataTable[dialogId] = nil
	end
end

function billingManager:setDialogCallback(dialogId, callback, callbackData)
	if(callback ~= nil) then
		if(self.callbackDataTable == nil)then
			self.callbackDataTable = {}
		end
		--check if the dialog currently displayed is removed 
		--by another incoming dialog message: it seems they are enqueued
		self.callbackDataTable[dialogId] = {}
		self.callbackDataTable[dialogId].callback = callback
		if(callbackData ~= nil) then
			self.callbackDataTable[dialogId].callbackData = callbackData
		end
	end
end

function billingManager:scheduleOkDialog(title, message1, message2, closeLabel, id, productId)
	if(self.scheduledOkDialogsTable[productId] == nil) then
		self.scheduledOkDialogsTable[productId] = {}
		self.scheduledOkDialogsTable[productId].dialog = {title = title, message1 = message1, message2 = message2, closeLabel = closeLabel, id = id}
	else
		local iter = self.scheduledOkDialogsTable[productId]
		while(iter.next ~= nil) do
			iter = iter.next
		end
		local newEntry = {}
		newEntry.dialog = {title = title, message1 = message1, message2 = message2, closeLabel = closeLabel, id = id}
		iter.next = newEntry
	end
end

function billingManager:registerGraphicInterface(graphicInterface)
	self.graphicInterface = graphicInterface
end

function billingManager:cancelled(event)
	dbg.print("billingManager:cancelled")
	system:sendEvent("purchaseFailed", {})
end

function billingManager:receiptAvailable(event)
	dbg.print("billingManager:receiptAvailable")
	--dbg.printTable(event)
	
	local currentHintsCount = g_getHintsCount()
	local currentFullGameFlag = g_isFullGameUnlocked()
	local productIdError = false
	local rollBackDataFlag = false
	
	if(event.productId == billingManager.UNLOCK_FULL_GAME_PROD_ID) then
		if(g_isFullGameUnlockRestoreTestEnabled())then
			dbg.print("testing unlck restore")
			if(event.restored == true)then
				billingManager:setUnlockFullGameFlag(1)
				dbg.print("unlck restored")
			else
				dbg.print("ignoring purhcase")
				--do nothing we need to test the restore
			end
		else
			billingManager:setUnlockFullGameFlag(1)
		end
	else
		if(billingManager.hintsQuantityTable[event.productId] ~= nil) then
			billingManager:setHintsCount(currentHintsCount + billingManager.hintsQuantityTable[event.productId])			
		else
			dbg.print("WARNING unmanaged product id was purchased " ..event.productId)
			productIdError = true
			rollBackDataFlag = true
		end 
	end	
	local fd = event.finaliseData
	if(productIdError == false) then
		if(g_saveData()) then
			if (billing:finishTransaction(event.finaliseData) == true) then
				dbg.print("transaction finalised successfully")
				if(event.restored == false) then
					--displaying or scheduling a dialog box that reports the completed purchase
					--android does not distinguish restore from purchase
					if(self.restoreRequesFlag ~= true) then
						if(g_isProductInfoDataAvailable(event.productId))then
							--added to manage the lack of dialog box extension on BB
							if( not dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_INFO), getString(S_MENU_MTX_STORE_SUCCESS_1) .. billingManager.availableProductInfosMap[event.productId].title ..getString(S_MENU_MTX_STORE_SUCCESS_2) , getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID)) then
								system:sendEvent("purchaseSuccessful", {})								
							end
						else
							dbg.print("WARNING: purchased product " ..event.productId.. " data not currently available, scheduling related purchase complete dialog box")
							--if the associated products info have not been retrieved yet the dialog is scheduled and will be displayed 
							--when this products info will be available
							billingManager:scheduleOkDialog(getString(S_IAP_DIALOG_TITLE_INFO), getString(S_MENU_MTX_STORE_SUCCESS_1), getString(S_MENU_MTX_STORE_SUCCESS_2), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID, event.productId)
						end
					else
						if(g_isProductInfoDataAvailable(event.productId))then
							if (not dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_INFO), getString(S_MENU_MTX_STORE_RESTORED_1) .. billingManager.availableProductInfosMap[event.productId].title ..getString(S_MENU_MTX_STORE_RESTORED_2), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID)) then
								system:sendEvent("purchaseSuccessful", {})
							end
						else
							billingManager:scheduleOkDialog(getString(S_IAP_DIALOG_TITLE_INFO), getString(S_MENU_MTX_STORE_RESTORED_1), getString(S_MENU_MTX_STORE_RESTORED_2), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID, event.productId)
						end
					end
				else
					if(g_isProductInfoDataAvailable(event.productId))then
						if (not dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_INFO), getString(S_MENU_MTX_STORE_RESTORED_1) ..billingManager.availableProductInfosMap[event.productId].title ..getString(S_MENU_MTX_STORE_RESTORED_2) , getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID)) then
							system:sendEvent("purchaseSuccessful", {})
						end
					else
						billingManager:scheduleOkDialog(getString(S_IAP_DIALOG_TITLE_INFO), getString(S_MENU_MTX_STORE_RESTORED_1), getString(S_MENU_MTX_STORE_RESTORED_2), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID, event.productId)
					end	
				end
			else
				dbg.print("Error finalising transaction")
				rollBackDataFlag = true
			end
		else
			dbg.print("Error saving data file on in app purchase")
			rollBackDataFlag = true
		end
	end
	if (rollBackDataFlag) then
		dbg.print("billingManager rolling back data: error occurred")
		billingManager:setHintsCount(currentHintsCount)
		if(currentFullGameFlag) then
			billingManager:setUnlockFullGameFlag(1)
		else
			billingManager:setUnlockFullGameFlag(0)
		end
        g_saveData()
	end
end

function billingManager:infoAvailable(event)

	self.availableProductInfosMap[event.productId] = {}
	self.availableProductInfosMap[event.productId].description = event.description
	--the price will be displayed by the store
	--self.availableProductInfosMap[event.productId].price = event.price
	self.availableProductInfosMap[event.productId].title = event.title
	system:sendEvent("productInfoUpdate", {})
	if (self.scheduledOkDialogsTable[productId] ~= nil) then
		local dialogTable = self.scheduledOkDialogsTable[productId].dialog
		self.scheduledOkDialogsTable = self.scheduledOkDialogsTable[productId].next--removing the first entry in the scheduled dialogs lilst
		--if( not dialogManager:displayOkDialog(dialogTable.title, dialogTable.message1 ..event.title ..dialogTable.message2, dialogTable.closeLabel, dialogTable.id)) then
		if( not dialogManager:displayOkDialog(dialogTable.title, dialogTable.message1 ..event.title ..dialogTable.message2, dialogTable.closeLabel, -238746)) then--this dialog box shall not trigger the purchaseComplete event since it is a deferred message
			if(dialogTable.id == billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID) then
				--system:sendEvent("purchaseSuccessful", {})--do not send the event, since this is a deferred event, unrelated to any graphic interface
			else
				--we should not be here, but we do not need to show a deferred error message if any anyway
			end
		end
	end

	g_retrieveProductsInfoData()--this will retrieve product info if needed
end

function billingManager:refundAvailable(event)
	dbg.print("*****************************")
	dbg.print("=============================")
	dbg.print("billingManager:refundAvailable")
	dbg.printTable(event)
	dbg.print("=============================")
end

function billingManager:getProductInfoData(productId)
	dbg.print("billingManager:getProductInfoData")
	dbg.printTable(self.availableProductInfosMap)
	if(self.availableProductInfosMap ~= nil)then
		if(self.availableProductInfosMap[productId] == nil)then
			dbg.print("error billingManager:getProductInfoData. Product entry " ..productId .." is nil")
		else
			dbg.print("product info entry")
			dbg.printTable(self.availableProductInfosMap[productId])
		end
		return self.availableProductInfosMap[productId]
	end
	return nil
	
	--[[
	if(self.productInfoDataTable ~= nil)then
		return self.productInfoDataTable[productId]
	end
	return nil
	--]]
end

--relying on the fact that in this game there is only one non consumable product
--see IwBilling and QBilling
function billingManager:billingResultOk(event)
	system:sendEvent("billingRequestCompleted", {})
	--[[
	if(event.productId == nil) then
		system:sendEvent("billingRequestCompleted", {})
	else
		if(event.productId == "") then
			system:sendEvent("billingRequestCompleted", {})
		end
	end
	--]]
end

function billingManager:billingError(event)
	dbg.print("billingManager:billingError")
	dbg.printTable(event)
	
	--on blackberry we do not need to show the error dialogs, we rely on the billing system messages
	local errorOccurred = true
	local dialogResult = false
	if (event.error == "BILLING_ERROR_PAYMENT_CANCELLED") then
		system:sendEvent("purchaseFailed", {})
		errorOccurred = false
		dbg.print("cancel event type")
	elseif (event.error == "BILLING_ERROR_RESTORE_FAILED") then
		--TODO is this just a restore canceled?
		dbg.print("billing error: no error")
	elseif (event.error == "BILLING_ERROR_NO_CONNECTION") then
		dialogResult = dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_DISCONNECTED), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)
	elseif (event.error == "BILLING_ERROR_CLIENT_INVALID" or event.error == "BILLING_ERROR_PAYMENT_NOT_ALLOWED" or event.error == "BILLING_ERROR_PURCHASE_DISABLED") then
		dialogResult = dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_BLOCKED), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)
	elseif (event.error == "BILLING_ERROR_CLIENT_INVALID" or event.error == "BILLING_ERROR_UNKNOWN_ERROR" or event.error == "BILLING_ERROR_FAILED" or event.error == "BILLING_ERROR_DEVELOPER_ERROR") then
		dialogResult = dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)
	elseif (event.error == "BILLING_ERROR_PURCHASE_UNKNOWN") then
		dialogResult = dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_INVALID_ID), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)
	else
		dbg.print("WARNING: unknown error code in billing error management : " ..event.error)
		--unknown error code
		dialogResult = dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), billingManager.DIALOG_BILLING_ERROR_ID)
	end
	if(dialogResult == false) then
		system:sendEvent("purchaseFailed", {})
	else
		dbg.print("dialogResult = " ..tostring(dialogResult ))
	end
	--[[
	if(errorOccurred and dialogErrorOccurred) then
		dbg.print("debug 1")
		system:sendEvent("purchaseFailed", {})
	elseif(dialogErrorOccurred and not errorOccurred) then
		dbg.print("debug 2")
	else
		dbg.print("debug 3")
	end
	--]]
end

function billingManager:billing(event)
	dbg.print("billingManager:billing event 1")
	system:sendEvent("transactionEnded", {})
	dbg.print("billingManager:billing event 2")
	dbg.printTable(event)
	if (event.type == "billingError") then
		billingManager:billingError(event)
	elseif (event.type == "cancelled") then
		billingManager:cancelled(event)
	elseif (event.type == "infoAvailable") then
		billingManager:infoAvailable(event)	
	elseif (event.type == "receiptAvailable") then
		billingManager:receiptAvailable(event)
	elseif (event.type == "refundAvailable") then
		billingManager:refundAvailable(event)
	elseif (event.type == "billingResultOk") then
		billingManager:billingResultOk(event)
	else
		dbg.print("error unknown billing event type")
		dbg.printTable(event)
	end
	self.restoreRequesFlag = nil
end

function billingManager:dialog(event)
	if(event.id == billingManager.DIALOG_BILLING_ERROR_ID) then
		system:sendEvent("purchaseFailed", {})
	elseif (event.id == billingManager.DIALOG_BILLING_PURCHASE_COMPLETE_ID) then
		system:sendEvent("purchaseSuccessful", {})
	else
		
	end
end

system:addEventListener({"billing", "dialog"}, billingManager)
