--[[
dialogManager = {}


function dialogManager:isDialogAvailable()
	return cmw.CMWDialog:IsDialogAvailable()
end


function dialogManager:displayOkDialog(title, msg, okButtonLabel, id)
	return cmw.CMWDialog:DisplayOkDialog(title, msg, okButtonLabel, id)
end

function dialogManager:displayOkCancelDialog(title, msg, okButtonLabel, cancelButtonLabel, id)
	return cmw.CMWDialog:DisplayOkCancelDialog(title, msg, okButtonLabel, cancelButtonLabel, id)
end

--]]

hintsPurchaseManager = {}


hintsPurchaseManager.HINT_PURCHASE_SPRITE		= {}

local purchaseHint_atlas_1 =  director:createAtlas( {
	width = 256,
	height = 199,
	numFrames = 2,
	textureName = "Assets/UI/mtx_bronze_hint.png"
	} )

local purchaseHint_anim_1 = director:createAnimation( {
	start = 1,
	count = 2,
	atlas = purchaseHint_atlas_1
	} )

hintsPurchaseManager.HINT_PURCHASE_SPRITE[1]	= { source = purchaseHint_anim_1, spriteY = 520, labelID = billingManager.HINT_PACK_BRONZE_PROD_ID }

local purchaseHint_atlas_2 =  director:createAtlas( {
	width = 256,
	height = 199,
	numFrames = 2,
	textureName = "Assets/UI/mtx_silver_hint.png"
	} )

local purchaseHint_anim_2 = director:createAnimation( {
	start = 1,
	count = 2,
	atlas = purchaseHint_atlas_2
	} )

hintsPurchaseManager.HINT_PURCHASE_SPRITE[2]	= { source = purchaseHint_anim_2, spriteY = 690, labelID = billingManager.HINT_PACK_SILVER_PROD_ID }

local purchaseHint_atlas_3 =  director:createAtlas( {
	width = 256,
	height = 199,
	numFrames = 2,
	textureName = "Assets/UI/mtx_gold_hint.png"
	} )

local purchaseHint_anim_3 = director:createAnimation( {
	start = 1,
	count = 2,
	atlas = purchaseHint_atlas_3
	} )


hintsPurchaseManager.HINT_PURCHASE_SPRITE[3]	= { source = purchaseHint_anim_3, spriteY = 860, labelID = billingManager.HINT_PACK_GOLD_PROD_ID }

--[[
hintsPurchaseManager.HINT_PURCHASE_SPRITE[1]	= { source = "Assets/UI/mtx_bronze_hint.png", spriteY = 520, labelID = billingManager.HINT_PACK_BRONZE_PROD_ID }
hintsPurchaseManager.HINT_PURCHASE_SPRITE[2]	= { source = "Assets/UI/mtx_silver_hint.png", spriteY = 690, labelID = billingManager.HINT_PACK_SILVER_PROD_ID }
hintsPurchaseManager.HINT_PURCHASE_SPRITE[3]	= { source = "Assets/UI/mtx_gold_hint.png", spriteY = 860, labelID = billingManager.HINT_PACK_GOLD_PROD_ID }
--]]

hintsPurchaseManager.IN_APP_PURCHASE_COMPLETE_EVENT_NAME = "inAppPurchaseComplete"

hintsPurchaseManager.PRODUCTS_ARRAY = {billingManager.UNLOCK_FULL_GAME_PROD_ID, billingManager.HINT_PACK_GOLD_PROD_ID, billingManager.HINT_PACK_SILVER_PROD_ID, billingManager.HINT_PACK_BRONZE_PROD_ID}

--FSM states
---------------------------------------------------------
hintsPurchaseManager.IDLE_STATE 							= -10
hintsPurchaseManager.INBOUND_ANIMATION_STATE 				= -20
hintsPurchaseManager.SHOWING_STATE 							= -30
hintsPurchaseManager.TRANSACTION_ACTIVE_STATE 				= -40
hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE 	= -50
hintsPurchaseManager.TRANSACTION_RESULT_FAILED_POPUP_STATE 	= -60
hintsPurchaseManager.OUTBOUND_ANIMATION_STATE				= -70
hintsPurchaseManager.RESTORING_PRODUCTS_STATE				= -80

---------------------------------------------------------

hintsPurchaseManager.PURCHASE_CONFIRM_DIALOG_ID = 1
hintsPurchaseManager.RESULT_DIALOG_ID = 2
DIALOGUE_CHEAT1 = 10000
DIALOGUE_CHEAT_LAST = 11000

hintsPurchaseManager.state 							= hintsPurchaseManager.IDLE_STATE
--hintsPurchaseManager.availableProductsDataTable		= {}

hintsPurchaseManager.WAITING_TIMEOUT				= 60.0--seconds

hintsPurchaseManager.updateTimer 					= 0
hintsPurchaseManager.graphicsPositionY 				= 0
hintsPurchaseManager.graphicsInitialPositionY		= 0
hintsPurchaseManager.graphicsVelocityY 				= 0
hintsPurchaseManager.showingPositionY				= 0
hintsPurchaseManager.graphicsRootNode				= nil
hintsPurchaseManager.hintpurchaseTitle				= nil
hintsPurchaseManager.closeButton					= nil
--hintsPurchaseManager.purchasedProductId				= nil

hintsPurchaseManager.debugInfoStateString			= ""
hintsPurchaseManager.debugErrorStateString			= ""

hintsPurchaseManager.debugLabelsVisible				= false

hintsPurchaseManager.MAX_SPEED_NO_SCALE					= 400

hintsPurchaseManager.CLOSE_BUTTON_REL_X					= 604
hintsPurchaseManager.CLOSE_BUTTON_REL_Y					= 227
hintsPurchaseManager.ORIG_BACKGROUND_HEIGHT 			= 1136

hintsPurchaseManager.HINT_PURCHASE_OPTION_REL_X			= 410
hintsPurchaseManager.HINT_PURCHASE_TITLE_REL_Y			= 330
hintsPurchaseManager.HINT_PURCHASE_LABEL_REL_Y			= -9

hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_REL_X	= -64
hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_REL_Y	= -26
hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_WIDTH	= 96
hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_HEIGHT	= 64

hintsPurchaseManager.HINT_PURCHASE_OPTION_LABEL_WIDTH			= 200
hintsPurchaseManager.HINT_PURCHASE_OPTION_LABEL_HEIGHT			= 150
hintsPurchaseManager.HINT_PURCHASE_OPTION_LABEL_REL_X			= 510


function hintsPurchaseManager:quit()
	--system:removeEventListener({ "appStore", "update", "dialog" }, self)
	--self:deactivate()
	system:removeEventListener( { "update", "productInfoUpdate", "transactionStarted", "transactionEnded", "purchaseFailed", "purchaseSuccessful", "backKey" }, self)
	
	
	system:sendEvent(hintsPurchaseManager.IN_APP_PURCHASE_COMPLETE_EVENT_NAME)
end

function hintsPurchaseManager:productInfoUpdate(event)
	--self:productsInfoUpdate()--TODO this might be simplified
	if (self.state == hintsPurchaseManager.INBOUND_ANIMATION_STATE) then
		--update graphics from the table self.productsDataTable
		self:fillProductsDescriptionGraphics()
	elseif (self.state == hintsPurchaseManager.SHOWING_STATE) then
		--update graphics from the table self.productsDataTable
		self:fillProductsDescriptionGraphics()
	else
		--do nothing.
	end
end

function hintsPurchaseManager:deactivate()
	dbg.print("*****************************")
	dbg.print("hintsPurchaseManager:deactivate")
	dbg.print("-----------------------------")
	
	system:removeEventListener( { "update", "productInfoUpdate", "transactionStarted", "transactionEnded", "purchaseFailed", "purchaseSuccessful", "backKey"}, self)
end

function hintsPurchaseManager:activate()
	dbg.print("*****************************")
	dbg.print("hintsPurchaseManager:activate")
	dbg.print("-----------------------------")
	-- Moved here because getString doesn't work above
	hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_1			= getString(S_IAP_WAITING)
	hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_2			= getString(S_IAP_WAITING) .. "."
	hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_3			= getString(S_IAP_WAITING) .. ".."
	hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_4			= getString(S_IAP_WAITING) .. "..."
	hintsPurchaseManager.waitingAnimationFrames = {hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_1, hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_2, hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_3, hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_4}
	hintsPurchaseManager.waitingAnimationTimer = 0.0
	hintsPurchaseManager.waitingAnimationLoopLength = 1.0

	system:addEventListener( { "update", "productInfoUpdate", "transactionStarted", "transactionEnded", "purchaseFailed", "purchaseSuccessful", "backKey" }, self)
end

--FSM signals
---------------------------------------------------------

function hintsPurchaseManager:showHintsRequest(graphicSceneRootNode)
	self:activate()
	dbg.print("showHintsRequest")
	self:startHintsPurchaseProcedure(graphicSceneRootNode)
end

function hintsPurchaseManager:startPurchaseHintProduct(prodId)
	--self.purchasedProductId = prodId
	self:startTransaction()
	local res = g_startProductPurchase(prodId)
	if(not res) then
		--TODO manage error
		dbg.print("ERROR hintsPurchaseManager:startPurchaseHintProduct")
	else
		dbg.print("hintsPurchaseManager:startPurchaseHintProduct OK")
	end
end

function hintsPurchaseManager:backKey(event)
	if(self.closeButton.isVisible) then
		self:closeSignal()
	end
end

function hintsPurchaseManager:activated(event)
    local targetNode = event.target
	if(targetNode == self.closeButton) then
		self:closeSignal()
	else
		if(self.state == hintsPurchaseManager.SHOWING_STATE) then			
			if (self.purchaseHintSprite[1] == targetNode) then
				self:startPurchaseHintProduct(billingManager.HINT_PACK_BRONZE_PROD_ID)
			elseif(self.purchaseHintSprite[2] == targetNode) then
				self:startPurchaseHintProduct(billingManager.HINT_PACK_SILVER_PROD_ID)
			elseif(self.purchaseHintSprite[3] == targetNode) then
				self:startPurchaseHintProduct(billingManager.HINT_PACK_GOLD_PROD_ID)
			end
		end
	end
end

function hintsPurchaseManager:transactionStarted(event)
	dbg.print("hintsPurchaseManager:transactionStarted")
	if not appStore:blockingTransactions() then
		self:changeState(hintsPurchaseManager.TRANSACTION_ACTIVE_STATE)
	end
end

function hintsPurchaseManager:transactionEnded(event)
	dbg.print("hintsPurchaseManager:transactionEnded")
	if(self.state ~= hintsPurchaseManager.OUTBOUND_ANIMATION_STATE)then
		self:changeState(hintsPurchaseManager.SHOWING_STATE)
	end
end

function hintsPurchaseManager:purchaseFailed(event)
	dbg.print("hintsPurchaseManager:purchaseFailed")
	self:changeState(hintsPurchaseManager.SHOWING_STATE)
end

function hintsPurchaseManager:purchaseSuccessful(event)
	dbg.print("hintsPurchaseManager:purchaseSuccessful")
	self:closeSignal()
end

function hintsPurchaseManager:getGraphicNodeInheritedXScale(node)
	local scale = 1.0
	local currentNode = node
	while(currentNode ~= nil) do
		scale = scale * currentNode.xScale
		currentNode = currentNode.parent
	end
	return scale
end

function hintsPurchaseManager:getGraphicNodeInheritedYScale(node)
	local scale = 1.0
	local currentNode = node
	while(currentNode ~= nil) do
		scale = scale * currentNode.yScale
		currentNode = currentNode.parent
	end
	return scale
end


function hintsPurchaseManager:createPurchaseHintsGraphics(graphicSceneRootNode)
	dbg.print("hintsPurchaseManager:createPurchaseHintsGraphics")
	local backgroundSpriteInitValues = {x=director.displayWidth / 2, y=-10000, xAnchor=0.5, yAnchor = 0.5, xScale=UI_SCALE, yScale=UI_SCALE, zOrder = 900, source="Assets/UI/mtx_layout.png"}
	local backgroundSprite = director:createSprite(backgroundSpriteInitValues)
	backgroundSprite.y = -backgroundSprite.h * self:getGraphicNodeInheritedYScale(backgroundSprite) 
		
	self.graphicsRootNode = backgroundSprite
	graphicSceneRootNode:addChild(self.graphicsRootNode)

	local atlas =  director:createAtlas( {
	width = 81,
	height = 105,
	numFrames = 2,
	textureName = "Assets/UI/close_button.png"
	} )
	
	local anim = director:createAnimation( {
	start = 1,
	count = 2,
	atlas = atlas
	} )
	
	local closeButton = director:createUIButton({x=backgroundSprite.x, y=backgroundSprite.y, xScale=UI_SCALE, yScale=UI_SCALE, xAnchor=0.5, yAnchor = 0.5, source=anim})
	closeButton:addEventListener("activated", self)
	
	closeButton.x = hintsPurchaseManager.CLOSE_BUTTON_REL_X	 
	closeButton.y = -hintsPurchaseManager.CLOSE_BUTTON_REL_Y + hintsPurchaseManager.ORIG_BACKGROUND_HEIGHT 
	closeButton.xScale = 1--inheriting the scale from the parent when attached
	closeButton.yScale = 1--inheriting the scale from the parent when attached
	closeButton.isVisible = false
	
	self.graphicsRootNode:addChild(closeButton)

	self.hintsProductsFieldsTable = {}

	self.hintPurchaseTitle = director:createLabel({
        x=self.graphicsRootNode.w/2, y=self.graphicsRootNode.h-400,
        w=director.displayWidth/self.graphicsRootNode.xScale,h=120,
        rotation=355,
        xAnchor=0.5, yAnchor=0,
        zOrder=1000,
        text=getString(S_MENU_BUY_HINTS),
        color=GAME_FONT_COLOR,
        font=GAME_FONT_TITLE,
        hAlignment="centre", vAlignment="middle"})
	self.graphicsRootNode:addChild(self.hintPurchaseTitle)
	
	self.purchaseHintSprite = {}

	for i = 1, #hintsPurchaseManager.HINT_PURCHASE_SPRITE do
	
		local values = {x=hintsPurchaseManager.HINT_PURCHASE_OPTION_REL_X, y=-hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].spriteY + hintsPurchaseManager.ORIG_BACKGROUND_HEIGHT, xAnchor=1.0, yAnchor = 0.5, zOrder = backgroundSprite.zOrder + 1, source=hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].source}
		--local sprite = director:createSprite(values)
		local sprite = director:createUIButton(values)
		sprite:addEventListener("activated", self)
		sprite.name = "purchase hint pack " .. i
		--sprite:addEventListener("touch", self)
		
		self.purchaseHintSprite[i] = sprite
		self.graphicsRootNode:addChild(sprite)
		
		hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].sprite = sprite
		
		local number = director:createLabel( {
			x=sprite.x + hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_REL_X,
			y=sprite.y + hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_REL_Y,
			w=hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_WIDTH,
			h=hintsPurchaseManager.HINT_PURCHASE_OPTION_NUMBER_HEIGHT,
			xAnchor=0.5, yAnchor=0.5,
			xScale=0.5, yScale=0.5,
			zOrder = sprite.zOrder + 1,
			text="" .. billingManager.hintsQuantityTable[hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].labelID],
			--text="blah blah",
			hAlignment = "centre",
			vAlignment = "middle",
			color=GAME_FONT_COLOR,
			font = GAME_FONT
			} )

		self.graphicsRootNode:addChild(number)
		
		local label = director:createLabel( {
			x=hintsPurchaseManager.HINT_PURCHASE_OPTION_LABEL_REL_X, 
			y=-hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].spriteY + hintsPurchaseManager.HINT_PURCHASE_LABEL_REL_Y + hintsPurchaseManager.ORIG_BACKGROUND_HEIGHT, 
			w=hintsPurchaseManager.HINT_PURCHASE_OPTION_LABEL_WIDTH,
			h=hintsPurchaseManager.HINT_PURCHASE_OPTION_LABEL_HEIGHT,
			xAnchor=0.5, yAnchor=0.5,
			textXScale=0.5, textYScale=0.5,
			zOrder = sprite.zOrder + 1,
			text="",
			hAlignment = "centre",
			vAlignment = "middle",
			color=GAME_FONT_COLOR,
			font = GAME_FONT
			} )
		
		self.hintsProductsFieldsTable[hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].labelID] = {}
		self.hintsProductsFieldsTable[hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].labelID].label = label
		self.hintsProductsFieldsTable[hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].labelID].sprite = sprite
		self.graphicsRootNode:addChild(label)
	end

	self.waitingAnimationLabel = director:createLabel( {
        x=self.graphicsRootNode.w / 2, y=self.graphicsRootNode.h-100,
        w=director.displayWidth/self.graphicsRootNode.xScale, h=100,
        isVisible = false,
		xAnchor=0.5, yAnchor=1.0,
		text=hintsPurchaseManager.WAITING_ANIMATION_LABEL_FRAME_1,
		color=GAME_FONT_COLOR,
		font=GAME_FONT,
	    hAlignment = "centre", vAlignment = "top"
    } )
	
	self.graphicsRootNode:addChild(self.waitingAnimationLabel)
	self.closeButton = closeButton
	self:fillProductsDescriptionGraphics()--this will update the buttons state

end

function hintsPurchaseManager:disableHintPurchaseButton(productId)
	if(self.hintsProductsFieldsTable ~= nil) then
		if(self.hintsProductsFieldsTable[productId] ~= nil) then
			self.hintsProductsFieldsTable[productId].sprite:disable()
		end
	end
end

function hintsPurchaseManager:enableHintPurchaseButton(productId)
	if(self.hintsProductsFieldsTable ~= nil) then
		if(self.hintsProductsFieldsTable[productId] ~= nil) then
			self.hintsProductsFieldsTable[productId].sprite:enable()
		end
	end
end

function hintsPurchaseManager:disableHintPurchaseButtons()
	for k,v in pairs(hintsPurchaseManager.HINT_PURCHASE_SPRITE) do
		if(v.sprite ~= nil) then
			--v.sprite:disable()
			hintsPurchaseManager:disableHintPurchaseButton(k)--it checks if the prod info are available
		end
	end
end

function hintsPurchaseManager:enableHintPurchaseButtons()
	for k,v in pairs(hintsPurchaseManager.HINT_PURCHASE_SPRITE) do
		if(v.sprite ~= nil) then
			--v.sprite:enable()
			hintsPurchaseManager:enableHintPurchaseButton(k)--it checks if the prod info are available
		end
	end
end

function hintsPurchaseManager:startHintsPurchaseProcedure(graphicSceneRootNode)
	dbg.print("hintsPurchaseManager:startHintsPurchaseProcedure")
	if (self.state == hintsPurchaseManager.IDLE_STATE) then
		--build graphics
		self:createPurchaseHintsGraphics(graphicSceneRootNode)		
		self:changeState(hintsPurchaseManager.INBOUND_ANIMATION_STATE)
	end
end

function hintsPurchaseManager:destroyGraphics()
	--self.fadeScreen = nil
	for i = 1, #hintsPurchaseManager.HINT_PURCHASE_SPRITE do
		hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].sprite:removeEventListener("activated", self)
		hintsPurchaseManager.HINT_PURCHASE_SPRITE[i].sprite = nil
	end
	self.closeButton = nil
	self.hintsProductsFieldsTable = nil
	self.graphicsRootNode:removeFromParent()
	self.graphicsRootNode = nil
	self.purchaseHintSprite = nil
	self.hintpurchaseTitle = nil
	self.waitingAnimationLabel:removeFromParent()
	self.waitingAnimationLabel = nil
end


function hintsPurchaseManager:animationComplete()
	dbg.print("hintsPurchaseManager:animationComplete")
	if (self.state == hintsPurchaseManager.INBOUND_ANIMATION_STATE) then
		self:changeState(hintsPurchaseManager.SHOWING_STATE)
	elseif hintsPurchaseManager.OUTBOUND_ANIMATION_STATE then
		self:destroyGraphics()
		--system:sendEvent(hintsPurchaseManager.IN_APP_PURCHASE_COMPLETE_EVENT_NAME)
		self:changeState(hintsPurchaseManager.IDLE_STATE)
		self:quit()
	else
		
	end
end

function hintsPurchaseManager:fillProductsDescriptionGraphics()
	dbg.print("calling fillProductsDescriptionGraphics")
	local netWorkError = false
	for k, element in pairs(self.hintsProductsFieldsTable) do
		dbg.print("calling fillProductsDescriptionGraphics k " ..k)
		local productInfoData = billingManager:getProductInfoData(k)
		if( productInfoData == nil)then
			self.hintsProductsFieldsTable[k].label.text = "..."
			self:disableHintPurchaseButton(k)
			if(appStore:isNetworkAvailable() and (not netWorkError))then
				g_retrieveProductsInfoData()
			else
				netWorkError = true
			end
		else
			--self.hintsProductsFieldsTable[k].text = element.title .."\n" ..element.formattedPrice 
			self.hintsProductsFieldsTable[k].label.text = productInfoData.titlewithbreaks
			self:enableHintPurchaseButton(k)
		end
	end
	if(netWorkError)then
		billingManager:displayNoNetworkConnectionDialog()
	end
end

--[[
function hintsPurchaseManager:setFullGameUnlockData(event)
	local productValues = {}
	productValues.formattedPrice = event.formattedPrice
	productValues.description = event.description
	productValues.title = event.title
	productValues.price = event.price
	productValues.priceLocale = event.priceLocale
	productValues.ready = true
	self.availableProductsDataTable[event.productId] = productValues
end
--]]
--[[
function hintsPurchaseManager:getFullGameUnlockFormattedPrice()
	local productTable = nil
	if(self.availableProductsDataTable ~= nil) then
		productTable = self.availableProductsDataTable[billingManager.UNLOCK_FULL_GAME_PROD_ID]
	end
	return productTable
end
--]]
--[[
function hintsPurchaseManager:productsInfoUpdate()
	if (self.state == hintsPurchaseManager.INBOUND_ANIMATION_STATE) then
		--update graphics from the table self.productsDataTable
		self:fillProductsDescriptionGraphics()
	elseif (self.state == hintsPurchaseManager.SHOWING_STATE) then
		--update graphics from the table self.productsDataTable
		self:fillProductsDescriptionGraphics()
	else
		--do nothing.
	end
end
--]]
function hintsPurchaseManager:startTransaction()
	if  (self.state == hintsPurchaseManager.SHOWING_STATE) then
		dbg.print("hintsPurchaseManager:startTransaction")
	end
end

function hintsPurchaseManager:transactionComplete()
	if (self.state == hintsPurchaseManager.TRANSACTION_ACTIVE_STATE) then
		--TODO?
	end
end

function hintsPurchaseManager:closeSignal()
	dbg.print("hintsPurchaseManager:closeSignal")
	if (self.state == hintsPurchaseManager.SHOWING_STATE) then
		self:changeState(hintsPurchaseManager.OUTBOUND_ANIMATION_STATE)
	elseif (self.state == hintsPurchaseManager.TRANSACTION_ACTIVE_STATE) then--user chose cancel on appstore purchase dialog
		self:changeState(hintsPurchaseManager.SHOWING_STATE)
		self:closeSignal()
	elseif (self.state == hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE) then
		self:changeState(hintsPurchaseManager.OUTBOUND_ANIMATION_STATE)
	elseif (self.state == hintsPurchaseManager.RESTORING_PRODUCTS_STATE) then
		self:changeState(hintsPurchaseManager.IDLE_STATE)
		self:closeSignal()
	elseif (self.state == hintsPurchaseManager.IDLE_STATE) then
		--system:sendEvent(hintsPurchaseManager.IN_APP_PURCHASE_COMPLETE_EVENT_NAME)
		self:quit()
	else
	
	end
end


---------------------------------------------------------

function hintsPurchaseManager:dialog(event)
	if(event.id>=DIALOGUE_CHEAT1 and event.id<DIALOGUE_CHEAT_LAST) then
		return
	end
	--TODO?
	--[[
	dbg.print("dialog event ")
	dbg.printTable(event)
	if (self.state == hintsPurchaseManager.TRANSACTION_RESULT_FAILED_POPUP_STATE) then
		self:changeState(hintsPurchaseManager.SHOWING_STATE)
	elseif (self.state == hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE) then
		self:closeSignal()
	elseif (self.state == hintsPurchaseManager.RESTORING_PRODUCTS_STATE) then
		if(event.id ~= -100)then--TODO change this constant id value to a global
			self:closeSignal()
		end
	elseif (self.state == hintsPurchaseManager.IDLE_STATE) then
		self:closeSignal()
	else
	
	end
	--]]
end

--FSM functions
---------------------------------------------------------

function hintsPurchaseManager:getCurrentStateString()
	return self:getStateString(self.state)
end

function hintsPurchaseManager:getStateString(stateValue)
	local stateString = "UNKNOWN"
	if (stateValue == hintsPurchaseManager.IDLE_STATE) then
		stateString = "hintsPurchaseManager.IDLE_STATE"
	elseif (stateValue == hintsPurchaseManager.INBOUND_ANIMATION_STATE) then
		stateString = "hintsPurchaseManager.INBOUND_ANIMATION_STATE"
	elseif (stateValue == hintsPurchaseManager.SHOWING_STATE) then
		stateString = "hintsPurchaseManager.SHOWING_STATE"
	elseif (stateValue == hintsPurchaseManager.TRANSACTION_ACTIVE_STATE) then
		stateString = "hintsPurchaseManager.TRANSACTION_ACTIVE_STATE"
	elseif (stateValue == hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE) then
		stateString = "hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE"
	elseif (stateValue == hintsPurchaseManager.TRANSACTION_RESULT_FAILED_POPUP_STATE) then
		stateString = "hintsPurchaseManager.TRANSACTION_RESULT_FAILED_POPUP_STATE"
	elseif (stateValue == hintsPurchaseManager.OUTBOUND_ANIMATION_STATE) then
		stateString = "hintsPurchaseManager.OUTBOUND_ANIMATION_STATE"
	elseif (stateValue == hintsPurchaseManager.RESTORING_PRODUCTS_STATE) then
		stateString = "hintsPurchaseManager.RESTORING_PRODUCTS_STATE"
	else
		stateString = "UNKNOWN_STATE " ..stateValue
	end
	dbg.print("hintsPurchaseManager:getStateString returning " ..stateString)
	return stateString
end


function hintsPurchaseManager:resetAnimationData()
	self.graphicsPositionY 				= self.graphicsRootNode.y
	self.graphicsVelocityY 				= 0
	self.showingPositionY				= director.displayHeight * 0.5
	self.graphicsInitialPositionY 		= self.graphicsRootNode.y
end

function hintsPurchaseManager:changeState(newState)
	if(newState ~= self.state) then
		if (newState == hintsPurchaseManager.IDLE_STATE ) then
			self:enableHintPurchaseButtons()
		elseif (newState == hintsPurchaseManager.INBOUND_ANIMATION_STATE ) then
			self:disableHintPurchaseButtons()
			self:resetAnimationData()
			self:fillProductsDescriptionGraphics()
			self.closeButton.isVisible = false
		elseif (newState == hintsPurchaseManager.SHOWING_STATE ) then
			self.waitingAnimationLabel.isVisible = false
			self.closeButton.isVisible = true
			self:enableHintPurchaseButtons()
		elseif (newState == hintsPurchaseManager.OUTBOUND_ANIMATION_STATE ) then
			self.closeButton.isVisible = true
			self:disableHintPurchaseButtons()
			--[[
			-- Fade screen back in behind pop-up
			tween:to(self.fadeScreen, { alpha = 0, delay = 0.5, time = 1 })
			--]]
		elseif (newState == hintsPurchaseManager.TRANSACTION_ACTIVE_STATE ) then
			self:disableHintPurchaseButtons()
			self.waitingAnimationLabel.isVisible = true
			self.waitingAnimationTimer = 0
			--self.waitingAnimationIndex = 1
			self.closeButton.isVisible = false
		elseif (newState == hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE ) then
			self:disableHintPurchaseButtons()
			self.closeButton.isVisible = false
		elseif (newState == hintsPurchaseManager.RESTORING_PRODUCTS_STATE ) then
			self:disableHintPurchaseButtons()
			self.waitingAnimationLabel.isVisible = true
		else
			--self.debugErrorStateLabel.text = "ERROR: hintsPurchaseManager:changeState -> unknown new state " ..newState
		end
		
		if ( self.state == hintsPurchaseManager.TRANSACTION_ACTIVE_STATE) then
			self.waitingAnimationLabel.isVisible = false
		elseif (self.state == hintsPurchaseManager.RESTORING_PRODUCTS_STATE ) then
			self.waitingAnimationLabel.isVisible = false
		end
		--self.debugInfoStateLabel.text = "hintsPurchaseManager:changeState from " ..self:getStateString(self.state) .." to " ..self:getStateString(newState)
		self.state = newState
		self.updateTimer = system.gameTime
		--dbg.print(" change state self.updateTimer " ..self.updateTimer)
	end
end


function hintsPurchaseManager:update(event)
	local dt = system.gameTime - self.updateTimer 
	self.updateTimer = system.gameTime 
	local DT_LIMIT = 0.05
	if(dt > DT_LIMIT)then--this is a trick to have the animation show smooth, although slower.
		--if the frame rate is too slow only one maximum dt is processed.
		--the remaining amount of time is lost
		dt = DT_LIMIT
	end
	if (self.state == hintsPurchaseManager.IDLE_STATE) then 
		
	elseif (self.state == hintsPurchaseManager.INBOUND_ANIMATION_STATE) then 
		--dbg.print("director.displayHeight " ..director.displayHeight .." director.displayWidth " ..director.displayWidth .." self.showingPositionY " ..self.showingPositionY )
		--dbg.print(" update self.updateTimer " ..self.updateTimer)
		local T = 0.175
		local dt_div_T = dt / T
		if (dt_div_T > 1.0) then
			dt_div_T = 1.0
		end
		local oldPos = self.graphicsPositionY
		self.graphicsPositionY = self.graphicsPositionY * (1.0 - dt_div_T) + self.showingPositionY * dt_div_T
		--dbg.print("self.graphicsPositionY " ..self.graphicsPositionY .. " targe " ..self.showingPositionY .." dt " ..dt)
		self.graphicsRootNode.y = self.graphicsPositionY 
		if(math.abs((self.graphicsPositionY - oldPos ) / oldPos) < 0.005) then
			self:animationComplete()
		end
	elseif (self.state == hintsPurchaseManager.SHOWING_STATE) then 
		local T = 0.175
		local dt_div_T = dt / T
		if (dt_div_T > 1.0) then
			dt_div_T = 1.0
		end
		local oldPos = self.graphicsPositionY
		self.graphicsPositionY = self.graphicsPositionY * (1.0 - dt_div_T) + self.showingPositionY * dt_div_T
		self.graphicsRootNode.y = self.graphicsPositionY 
	elseif (self.state == hintsPurchaseManager.OUTBOUND_ANIMATION_STATE) then 
		local T = 0.175
		local acc = -hintsPurchaseManager.MAX_SPEED_NO_SCALE * UI_SCALE / T
		self.graphicsVelocityY = self.graphicsVelocityY + acc * dt
		--TODO clamp to maximum velocity?
		self.graphicsPositionY = self.graphicsPositionY + self.graphicsVelocityY * dt
		--dbg.print("self.animation_pos_y " ..self.animation_pos_y )
		self.graphicsRootNode.y = self.graphicsPositionY 
		if (self.graphicsPositionY < self.graphicsInitialPositionY) then
			self:animationComplete()
		end
	elseif (self.state == hintsPurchaseManager.TRANSACTION_ACTIVE_STATE ) then
		
		local framesCount = #self.waitingAnimationFrames
		local animFrameLength = self.waitingAnimationLoopLength / framesCount
		self.waitingAnimationTimer = self.waitingAnimationTimer + dt
		--lua array are 1 based hence the + 1 in the end of the following statement
		
		local waitingAnimationIndex = math.floor(self.waitingAnimationTimer / animFrameLength)
		--a % b == a - math.floor(a/b)*b
		waitingAnimationIndex = waitingAnimationIndex - math.floor(waitingAnimationIndex / framesCount) * framesCount		
		waitingAnimationIndex = waitingAnimationIndex + 1 -- LUA indexes arrays elements from one
		--dbg.print("waitingAnimationIndex " ..waitingAnimationIndex .." framesCount " ..framesCount)-- .." text " ..self.waitingAnimationFrames[waitingAnimationIndex] )
		self.waitingAnimationLabel.text = self.waitingAnimationFrames[waitingAnimationIndex]
		if(self.waitingAnimationTimer >= hintsPurchaseManager.WAITING_TIMEOUT)then
			--self:changeState(hintsPurchaseManager.TRANSACTION_RESULT_FAILED_POPUP_STATE)
			self:changeState(hintsPurchaseManager.SHOWING_STATE)
			dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), hintsPurchaseManager.RESULT_DIALOG_ID)
		end
	elseif(self.state == hintsPurchaseManager.RESTORING_PRODUCTS_STATE) then
		local framesCount = #self.waitingAnimationFrames
		local animFrameLength = self.waitingAnimationLoopLength / framesCount
		self.waitingAnimationTimer = self.waitingAnimationTimer + dt
		--lua array are 1 based hence the + 1 in the end of the following statement
		
		local waitingAnimationIndex = math.floor(self.waitingAnimationTimer / animFrameLength)
		--a % b == a - math.floor(a/b)*b
		waitingAnimationIndex = waitingAnimationIndex - math.floor(waitingAnimationIndex / framesCount) * framesCount		
		waitingAnimationIndex = waitingAnimationIndex + 1 -- LUA indexes arrays elements from one
		--dbg.print("waitingAnimationIndex " ..waitingAnimationIndex .." framesCount " ..framesCount)-- .." text " ..self.waitingAnimationFrames[waitingAnimationIndex] )
		self.waitingAnimationLabel.text = self.waitingAnimationFrames[waitingAnimationIndex]		
		if(self.waitingAnimationTimer >= hintsPurchaseManager.WAITING_TIMEOUT)then
			self:changeState(hintsPurchaseManager.TRANSACTION_RESULT_FAILED_POPUP_STATE)
			dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_IAP_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), hintsPurchaseManager.RESULT_DIALOG_ID)
		end
	elseif (self.state == hintsPurchaseManager.TRANSACTION_RESULT_SUCC_POPUP_STATE) then
		
	--elseif (self.state == hintsPurchaseManager.PURCHASE_CONFIRM_POPUP_STATE ) then

	else
		--self.debugErrorStateLabel.text = "ERROR: hintsPurchaseManager:update -> unknown state " ..self.state
	end	
end
---------------------------------------------------------

--[[
function hintsPurchaseManager:retrieveData()
	dbg.print("WARNING hintsPurchaseManager:retrieveData shall be removed!!")
end
--]]

--[[
function hintsPurchaseManager:initializeDefaultData()
	--self.hintsCount = hintsPurchaseManager.DEFAULT_HINTS_COUNT
	--self.fullGameUnlocked = hintsPurchaseManager.DEFAULT_FULL_GAME_UNLOCKED
end
--]]
--[[
function hintsPurchaseManager:getFullGameUnlockedString()
	local stringValue = hintsPurchaseManager.FULL_GAME_LOCKED_STR
	if (self.fullGameUnlocked) then
		stringValue = hintsPurchaseManager.FULL_GAME_UNLOCKED_STR
	end
	return stringValue 
end
--]]

--[[
function hintsPurchaseManager:getHintsCountString()
	return ("" ..self:getHintsCount())
end
--]]

--[[
function hintsPurchaseManager:isFullGameUnlocked()
	return self.fullGameUnlocked
end
--]]
--[[
function hintsPurchaseManager:hintConsumed()
	--self.hintsCount = self.hintsCount - 1
	--g_saveData(self)
end
--]]
--[[
function hintsPurchaseManager:getHintsCount()
	return self.hintsCount
end
--]]
--[[
function hintsPurchaseManager:unlockFullGamePurchased()
	dbg.print("*********************************************")
	dbg.print("hintsPurchaseManager:unlockFullGamePurchased")
	--dbg.print(""..dbg.getProcessedCallstack())
	dbg.print("---------------------------------------------")
	self:unlockFullGame()
	g_saveData(self)
end
--]]
--[[
function hintsPurchaseManager:hintsPurchased(purchasedHintsCount)
	--dbg.print("hintsPurchaseManager:hintsPurchased " ..purchasedHintsCount .." hints")
	--self.hintsCount = self.hintsCount + purchasedHintsCount
	--dbg.print("hintsPurchaseManager:hintsPurchased hints count" ..self.hintsCount)
	--g_saveData(self)
end
--]]
--[[
function hintsPurchaseManager:dataLoaded(hintsCountStr)
	self.hintsCount = tonumber(hintsCountStr)
	dbg.assert(self.hintsCount ~= nil, "Error: loaded hints count has non valid format." ..hintsCountStr)
end
--]]
--[[
function hintsPurchaseManager:dataLoaded(hintsCountStr, fullGameUnlockedStr)
	self.hintsCount = tonumber(hintsCountStr)
	dbg.assert(self.hintsCount ~= nil, "Error: loaded hints count has non valid format." ..hintsCountStr)
	self.fullGameUnlocked = (fullGameUnlockedStr == hintsPurchaseManager.FULL_GAME_UNLOCKED_STR)	
end
--]]
--[[
function hintsPurchaseManager:unlockFullGame()
	self.fullGameUnlocked = true
end
--]]
--[[
function hintsPurchaseManager:updatePurchasedHintsProduct(prodId, quantity)
	if(self.hintsQuantityTable[prodId] ~= nil) then
		self:hintsPurchased(self.hintsQuantityTable[prodId] * quantity)
	else
		return false
	end
	return true
end
--]]
function hintsPurchaseManager:isVisible()
	--dbg.print("hintsPurchaseManager:isVisible current state " .. self:getCurrentStateString())
	return (self.state ~= hintsPurchaseManager.IDLE_STATE)
end
--[[
function hintsPurchaseManager:areAllProdsInfoAvailable()
	local avail = true
	for k,v in pairs(self.availableProductsDataTable) do
		avail = v.ready and avail
	end
	return avail
end
--]]
--dbg.print("hintsPurchaseManager functions declarations complete")

--system:addEventListener( { "appStore", "update", "dialog" }, hintsPurchaseManager)
