tutorialsManager = {}

tutorialsManager.performedFixedTutorialsTable = {}
tutorialsManager.performedFixedTutorialsTableLoaded = false

tutorialsManager.achievedContextTutorialsTable = {}
tutorialsManager.performedContextTutorialsTableLoaded = false

tutorialsManager.MAX_SPEED_NO_SCALE = 400

tutorialsManager.IDLE_STATE 				= -500
tutorialsManager.INBOUND_ANIMATION_STATE 	= -1000
tutorialsManager.OUTBOUND_ANIMATION_STATE 	= -2000
tutorialsManager.SHOWING_ANIMATION_STATE 	= -3000


tutorialsManager.MAX_WORLD_LEVEL_NUMBER = 99999-- default not achieved value = -9999
--tutorialsManager.MAX_WORLD_LEVEL_NUM_FIGURES = string.len(tutorialsManager.MAX_WORLD_LEVEL_NUMBER)
tutorialsManager.MAX_TILES_TYPES = 99
--tutorialsManager.MAX_TILE_TYPES_NUM_FIGURES = string.len(tutorialsManager.MAX_TILES_TYPES)


tutorialsManager.state = tutorialsManager.IDLE_STATE

--tutorialsManager.closeFlag 					= false--if true the current tutorial has been scheduled to be closed

--when the state will be SHOWING_ANIMATION_STATE the outbound animation will be triggered

--tutorialsManager.currentFixedTutorial = {}

--declaration of variables to show their structure
tutorialsManager.tutorialsStack = nil
tutorialsManager.tutorialStackElement = {}
tutorialsManager.tutorialStackElement.tutorialId = -1
tutorialsManager.tutorialStackElement.isContextTutorial = false
tutorialsManager.tutorialStackElement.previous = nil
tutorialsManager.tutorialStackElement.worldNumber = nil
tutorialsManager.tutorialStackElement.levelNumber = nil

tutorialsManager.timer 						= 0
tutorialsManager.animation_pos_y 			= 0
tutorialsManager.animation_vel_y			= 0 
tutorialsManager.startY						= 0
tutorialsManager.goalY						= 0

tutorialsManager.enabled				= false


dofile("Tutorials/tutorialsTable.lua")	


tutorialsManager.availableTutorialsTable = g_tutorialsTable --just created in "tutorialsTable.lua"


function tutorialsManager:getGraphicNodeInheritedXScale(node)
	local scale = 1.0
	local currentNode = node
	while(currentNode ~= nil) do
		scale = scale * currentNode.xScale
		currentNode = currentNode.parent
	end
	return scale
end

function tutorialsManager:getGraphicNodeInheritedYScale(node)
	local scale = 1.0
	local currentNode = node
	while(currentNode ~= nil) do
		scale = scale * currentNode.yScale
		currentNode = currentNode.parent
	end
	return scale
end

function tutorialsManager:getNodeActualWidth(node)
	return node.w * self:getGraphicNodeInheritedXScale(node)
end


function tutorialsManager:getNodeActualHeight(node)
	return node.h * self:getGraphicNodeInheritedYScale(node)
end


function tutorialsManager:getStateString(state)
	local string = "UNKNOWN_TUTORIAL_ANIMATION_STATE"
	if(state == tutorialsManager.IDLE_STATE) then
		string = "IDLE_STATE"
	elseif(state == tutorialsManager.INBOUND_ANIMATION_STATE) then
		string = "INBOUND_ANIMATION_STATE"
	elseif(state == tutorialsManager.OUTBOUND_ANIMATION_STATE) then
		string = "OUTBOUND_ANIMATION_STATE"	
	elseif(state == tutorialsManager.SHOWING_ANIMATION_STATE) then
		string = "SHOWING_ANIMATION_STATE"
	else
		
	end
	return string
end

function tutorialsManager:getCurrentStateString()
	return self:getStateString(self.state)
end

function tutorialsManager:changeState(newState)
	if (newState ~= tutorialsManager.state) then
		if(newState == tutorialsManager.INBOUND_ANIMATION_STATE) then
			self.timer = system.gameTime
			
		elseif (newState == tutorialsManager.SHOWING_ANIMATION_STATE) then
		
		elseif (newState == tutorialsManager.OUTBOUND_ANIMATION_STATE) then
			
		else
		
		end
		
		--dbg.print("tutorialsManager:changeState from " ..self:getCurrentStateString() .." to " ..self:getStateString(newState))
		self.state = newState
	end
end

function tutorialsManager:pushTutorialToStack(tutorialIdString, isContextTutorial, worldNumberString, levelNumberString)
	local tutorialStackElement = {}
	tutorialStackElement.tutorialId = tutorialIdString
	tutorialStackElement.isContextTutorial = isContextTutorial
	tutorialStackElement.worldNumber = worldNumberString
	tutorialStackElement.levelNumber = levelNumberString
	if(self.tutorialsStack == nil) then
		self.tutorialsStack = tutorialStackElement
	else
		tutorialStackElement.previous = self.tutorialsStack
		self.tutorialsStack = tutorialStackElement
	end
	
	--debug print of the stack
	
end

function tutorialsManager:printStack()

	--dbg.print("========================================")
	--dbg.print("========================================")
	--dbg.print("========================================")
	dbg.print("PRINTING TUTORIAL STACK")
	local stackIter = self.tutorialsStack
	while(stackIter ~= nil) do
		--dbg.print(stackIter.tutorialId)
		--dbg.printTable(stackIter)
		stackIter = stackIter.previous
	end
end

function tutorialsManager:popTutorialFromStack()	
	if(self.tutorialsStack ~= nil) then
		self.tutorialsStack = self.tutorialsStack.previous
	end	
	--[[
	local element = self.tutorialsStack
	if(self.tutorialsStack ~= nil) then
		self.tutorialsStack = self.tutorialsStack.previous
	end
	return element
	--]]
end

function tutorialsManager:peekTutorialFromStack()	
	return self.tutorialsStack--caller shall check if this is nil
end


function tutorialsManager:loadPerformedContextTutorialsData()
	local file = io.open("tutorials/performed_tutorials.txt", "r")
	if(file ~= nil) then
		local line = file:read()
		while (line ~= nil) do
			if(string.len(line) > 0) then
				local ps, pe = string.find(line, "=")
				local tutId = string.sub(line, 1, pe-1)
				local tutIdAchievedFlagStr = string.sub(line, pe+1)
				if(tonumber(tutIdAchievedFlagStr) ~= 0) then
					self.achievedContextTutorialsTable[tutId] = true
				else
					--self.achievedContextTutorialsTable[tutId] = false
				end
			end
			line = file:read()
		end
		file:close()
		self.performedContextTutorialsTableLoaded = true
		--dbg.print("performed context tutorial loaded")
		--dbg.printTable(self.achievedContextTutorialsTable)
	else
		--dbg.print("ERROR: saved performed context tutorials file not found")
		self:createDefaultContextTutorialsFile()
	end
end

function tutorialsManager:resetAllTutorials()
	self.achievedContextTutorialsTable = {}
	self.performedFixedTutorialsTable = {}
	
	--dbg.print("----------------tutorialsManager:addFixedtutorialsToPerformedList " ..tutorialIdString ..", " ..worldNumber ..", " ..levelNumber )
	--self.performedFixedTutorialsTable[tutorialIdString] = {}
	for i = 1,99 do
		local tutId = ""..i--the table key does not use the leading zeroes
		self.performedFixedTutorialsTable[tutId] = {}
		self.performedFixedTutorialsTable[tutId].levelNumber = -9999
		self.performedFixedTutorialsTable[tutId].worldNumber = -9999;
	--dbg.printTable(self.performedFixedTutorialsTable)
	end
end

function tutorialsManager:addLeadingZeroes(maxFiguresNum, strValue)
	--dbg.print("tutorialsManager:addLeadingZeroes " ..maxFiguresNum ..", strValue " ..strValue)
	local leadingZeroesCount = maxFiguresNum - string.len(strValue)
	--dbg.print("leadingZeroesCount " ..leadingZeroesCount )
	local formattedStr = ""
	for i=1, leadingZeroesCount do
		formattedStr = formattedStr .. "0"
	end
	formattedStr = formattedStr ..strValue
	return formattedStr 
end

function tutorialsManager:formatFixedTutorialData(tutorialTable)
	--tutorialsManager.MAX_WORLD_LEVEL_NUMBER
	--MAX_WORLD_LEVEL_NUM_FIGURES
	--MAX_TILE_TYPES_NUM_FIGURES 
	--local formattedTutorialId = self:addLeadingZeroes(string.len(tutorialsManager.MAX_TILES_TYPES), tutorialTable.tutorialId)
	local formattedWorldNumber = self:addLeadingZeroes(string.len(tutorialsManager.MAX_WORLD_LEVEL_NUMBER), tutorialTable.worldNumber)
	local formattedLevelNumber = self:addLeadingZeroes(string.len(tutorialsManager.MAX_WORLD_LEVEL_NUMBER), tutorialTable.levelNumber)
	local formattedDataTable = {}
	--formattedDataTable.tutorialId = formattedTutorialId
	formattedDataTable.worldNumber = formattedWorldNumber
	formattedDataTable.levelNumber = formattedLevelNumber
	--dbg.printTable(formattedDataTable)
	return formattedDataTable
end

function tutorialsManager:createDefaultContextTutorialsFile()
	local saveFilePath = "tutorials/performed_tutorials.txt"
	local file = io.open(saveFilePath, "w")
	if (file ~= nil) then
		local stringValues = ""
		for k,v in pairs(g_contextTutorialsTable) do
		--for i=1, tutorialsManager.MAX_TILES_TYPES do
			stringValues = stringValues ..k .."=0\n"
		end
		stringValues = string.sub(stringValues, 1, string.len(stringValues) - 1) 
		--dbg.print("BEFORE file:write " ..saveFilePath)
		file:write(stringValues)
		--dbg.print("AFTER file:write " ..saveFilePath)
		file:close()
	else
		dbg.print("!!!!!!!!!!!!!!!ERROR: Unable to open file in write mode. " ..saveFilePath)
		dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_SAVE_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), -10000)--the dialog id is not important here
	end
end


function tutorialsManager:createDefaultFixedTutorialsFile()
	--dbg.print("tutorialsManager:createDefaultFixedTutorialsFile")
	local saveFilePath = "tutorials/performed_fixed_tutorials.txt"
	local file = io.open(saveFilePath, "w")
	if (file ~= nil) then
		local stringValues = ""
		--for k,v in pairs(self.achievedContextTutorialsTable) do
		for i=1, tutorialsManager.MAX_TILES_TYPES do
			if(i<10) then
				stringValues = stringValues .."0" ..i .."=-9999,-9999\n"
			else
				stringValues = stringValues ..i .."=-9999,-9999"
				if(i ~= tutorialsManager.MAX_TILES_TYPES)then
					stringValues = stringValues .."\n"
				end
			end
			--stringValues = stringValues ..k.."\n"
		end
		--dbg.print("BEFORE file:write " ..saveFilePath)
		file:write(stringValues)
		--dbg.print("AFTER file:write " ..saveFilePath)
		file:close()
	else
		--dbg.print("!!!!!!!!!!!!!!!ERROR: Unable to open file in write mode. " ..saveFilePath)
		dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_SAVE_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), -10000)--the dialog id is not important here
	end
end

function tutorialsManager:loadPerformedFixedTutorialsData()
	local file = io.open("tutorials/performed_fixed_tutorials.txt", "r")
	if(file ~= nil) then
		local line = file:read()
		while (line ~= nil) do
			if(string.len(line) > 0) then
				--dbg.print("line " ..line)
				local ps, pe = string.find(line, "=")
				dbg.assert(ps ~= nil and pe ~= nil, "Error loading tutorials/performed_fixed_tutorials.txt. Line = " ..line)
				--dbg.print("ps " ..ps ..", " ..pe)
				local tutorialKey = string.sub(line, 1, pe-1)
				tutorialKey = "" ..tonumber(tutorialKey)--removing leading zeroes
				local data = string.sub(line, pe + 1)
				--dbg.print("data " ..data)
				local ps1, pe1 = string.find(data, "," )
				--dbg.print("ps " ..ps1 ..", " ..pe1)
				local worldNumber = string.sub(data, 1, pe1 - 1)
				worldNumber = "" ..tonumber(worldNumber)--removing leading zeroes
				local levelNumber = string.sub(data, pe1 + 1)
				levelNumber = "" ..tonumber(levelNumber)--removing leading zeroes
				self:addFixedtutorialsToPerformedList(tutorialKey, worldNumber, levelNumber)
			end
			line = file:read()
		end
		file:close()
		self.performedFixedTutorialsTableLoaded = true
	else
		--dbg.print("Error: saved performed tutorials file not found")
		self:createDefaultFixedTutorialsFile()
		self:loadPerformedFixedTutorialsData()
	end
end

function tutorialsManager:getCurrentActiveTutorialId()
	local id = nil
	if(self.tutorialsStack ~= nil)then
		id = self.tutorialsStack.tutorialId
	end
	return id
end

function tutorialsManager:getWorldId()
	return self.worldNumberStr
end

function tutorialsManager:getLevelId()
	return self.levelNumberStr
end

function tutorialsManager:isFixedTutorialAchieved(tutorialTable)
	return (tonumber(tutorialTable.worldNumber) > 0 and tonumber(tutorialTable.levelNumber) > 0)
end

function tutorialsManager:gridGenerated(usedTileTypes, worldNumber, levelNumber )
	self.enabled = true
	if(self.performedFixedTutorialsTableLoaded == false)then
		self:loadPerformedFixedTutorialsData()
	end
	if(self.performedContextTutorialsTableLoaded == false) then
		self:loadPerformedContextTutorialsData()
	end
	local worldNumberStr = ""..worldNumber
	local levelNumberStr = ""..levelNumber
	self.worldNumberStr = worldNumberStr
	self.levelNumberStr = levelNumberStr
	for k, v in pairs(usedTileTypes) do
		local tutorialIdString = ""..k
		dbg.print("tutorialIdString " ..tutorialIdString)
		--if(self.performedFixedTutorialsTable[tutorialIdString] ~= nil) then
		--dbg.print("XXXXXXXXXXXXXXXXXXXXXXXZZZZZZZZZZZZZZZZYYYYYYYYYYYYYY")
		--dbg.printTable(self.performedFixedTutorialsTable[tutorialIdString])
		--dbg.print("worldNumber " ..worldNumber .." levelNumber "  ..levelNumber)
		--if(self.performedFixedTutorialsTable[tutorialIdString] ~= nil) then
		if(tonumber(self.performedFixedTutorialsTable[tutorialIdString].worldNumber) > 0 and tonumber(self.performedFixedTutorialsTable[tutorialIdString].levelNumber) > 0) then
			--dbg.print("fixed tutorial achieved")
			--dbg.printTable(self.performedFixedTutorialsTable[tutorialIdString])
			if(self.performedFixedTutorialsTable[tutorialIdString].worldNumber == worldNumberStr and self.performedFixedTutorialsTable[tutorialIdString].levelNumber == levelNumberStr) then	
				self:pushTutorialToStack(tutorialIdString, false, worldNumberStr, levelNumberStr)
				self:showFixedTutorial(tutorialIdString, worldNumberStr, levelNumberStr)
				return --WARNING no check if we need to show multiple tutorials
			end
		else
			--dbg.print("fixed tutorial not achieved")
			self:pushTutorialToStack(tutorialIdString, false, worldNumberStr, levelNumberStr)
			self:showFixedTutorial(tutorialIdString, worldNumberStr, levelNumberStr)
			return --WARNING no check if we need to show multiple tutorials
		end
		--else
			
		--end
	end
end

function tutorialsManager:addFixedtutorialsToPerformedList(tutorialIdString, worldNumber, levelNumber)
	--dbg.print("----------------tutorialsManager:addFixedtutorialsToPerformedList " ..tutorialIdString ..", " ..worldNumber ..", " ..levelNumber )
	self.performedFixedTutorialsTable[tutorialIdString] = {}
	self.performedFixedTutorialsTable[tutorialIdString].levelNumber = levelNumber
	self.performedFixedTutorialsTable[tutorialIdString].worldNumber = worldNumber
	--dbg.printTable(self.performedFixedTutorialsTable)
end

function tutorialsManager:savePerformedContextTutorial(contextTutorialId)
	self.achievedContextTutorialsTable[contextTutorialId] = g_contextTutorialsTable[contextTutorialId]
	local saveFilePath = "tutorials/performed_tutorials.txt"
	local file = io.open(saveFilePath, "w")
	if (file ~= nil) then
		dbg.print("===============>>>>>>> Saving performed tutorials to " ..saveFilePath)
		local stringValues = ""
		--for k,v in pairs(self.achievedContextTutorialsTable) do
		local count = 0
		for k,v in pairs(g_contextTutorialsTable) do
			count = count + 1
		end
		local index = 0
		for k,v in pairs(g_contextTutorialsTable) do
			index = index + 1
			if(self.achievedContextTutorialsTable[k] ~= nil) then
				stringValues = stringValues ..k.."=1"
			else
				stringValues = stringValues ..k.."=0"
			end
			if(index < count) then
				stringValues = stringValues .."\n"
			end
		end
		--string.sub(stringValues, 1, string.len(stringValues) - 1)
		file:write(stringValues)
		file:close()
	else
		self.achievedContextTutorialsTable[contextTutorialId] = nil
		dbg.print("!!!!!!!!!!!!!!!ERROR: Unable to open file in write mode. " ..saveFilePath)
		dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_SAVE_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), -10000)--the dialog id is not important here
	end
end

function tutorialsManager:onBlockRewinded(event)
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			v:onBlockRewinded(event)
		end	
	end
end

function tutorialsManager:onBlockChanged(gameGrid, block)
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			v:onBlockChanged(gameGrid, block)
		end
	end
end

function tutorialsManager:hintButtonPressed()
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			v:hintButtonPressed()
		end	
	end
end

function tutorialsManager:skipCurrentLevel()
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			if(v.skippingButtonUsed ~= nil) then
				v:skippingButtonUsed()
			end
		end	
	end		
end

function tutorialsManager:skipButtonVisible(event)
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			if(v.skipButtonVisibleEvent ~= nil) then
				v:skipButtonVisibleEvent()
			end
		end	
	end	
end

function tutorialsManager:skipButtonInVisible(event)
	dbg.print("tutorialsManager:skipButtonInVisible")
	--g_contextTutorialsTable[skippingButtonTutorial.id]:skipButtonInVisibleEvent()
	skippingButtonTutorial:skipButtonInVisibleEvent()
	
	--[[
	self:printStack()
	local tutorial = self:peekTutorialFromStack()

	if(tutorial ~= nil)then
		dbg.print("debug 1")
	--if the skip button tutorial is on the top of the stack it will remove itself with the achieved function
		if(tutorial.tutorialId ~= skippingButtonTutorial.id) then
			--search for the skipbutton tutorial, because it is not on the top of the stack
			dbg.print("debug 2")
			local toRemoveTutorial = nil
			local previousTutorial = tutorial
			tutorial = tutorial.previous--if we are here the top of the stack is not the tutorial to be removed
			while(tutorial ~= nil and toRemoveTutorial == nil) do
				dbg.print("tutorial.tutorialId " ..tutorial.tutorialId)
				if(tutorial.tutorialId == skippingButtonTutorial.id) then
					dbg.print("found skip tutorial to remove")
					dbg.printTable(g_contextTutorialsTable[tutorial.tutorialId])
					g_contextTutorialsTable[tutorial.tutorialId]:canceled()
					toRemoveTutorial = tutorial
				else
					previousTutorial = tutorial
					tutorial = tutorial.previous
				end
			end
			if(toRemoveTutorial ~= nil)then
				dbg.print("removing tutorial " ..tutorial.tutorialId .." from the stack")
				previousTutorial.previous = tutorial.previous--this way the current tutorial (that is "tutorial" has been removed)
			end
		else
			g_contextTutorialsTable[tutorial.tutorialId]:dismissed()
		end
	end
	--]]
end

function tutorialsManager:hintUsed(startFromX, startFromY)
	dbg.print("tutorialsManager:hintUsed startFromX " ..startFromX)
	dbg.print("tutorialsManager:hintUsed startFromY " ..startFromY )
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			dbg.print("v:hintUsed tutorial " ..v.id )
			v:hintUsed(startFromX, startFromY)
		end	
	end
end

function tutorialsManager:setUp(parentSceneNode)
	tutorialsManager:initializeGraphics(parentSceneNode)
end

function tutorialsManager:destroy()
	self:changeState(tutorialsManager.IDLE_STATE)
	if self.backgroundSprite ~= nil then
		self.backgroundSprite:removeFromParent()
	end
	self.backgroundSprite = nil
	self.tutorialTextLabel = nil
end

function tutorialsManager:initializeGraphics(parentSceneNode)
	--if(self.backgroundSprite == nil) then

		self.backgroundSprite = director:createSprite(0, 0, "Assets/UI/tutorial_background.png")
		parentSceneNode:addChild(self.backgroundSprite)

		local tutorialTextLabel = director:createLabel( {
            hAlignment="centre", vAlignment="middle",
		    textXScale=0.35, textYScale=0.35,
		    text="",
		    color=GAME_FONT_COLOR,
		    font = GAME_FONT_TITLE,
            textBorderLeft=60,
            textBorderRight=60,
            textBorderTop=60,
            textBorderBottom=30
		} )
		
		--dbg.print("label y position" ..tutorialTextLabel.y .. " label height " ..tutorialTextLabel.h)
		self.backgroundSprite:addChild(tutorialTextLabel)
		self.tutorialTextLabel = tutorialTextLabel
		
	--end
	self.backgroundSprite.zOrder = parentSceneNode.zOrder + 500
	self.backgroundSprite.xScale = UI_SCALE
	self.backgroundSprite.yScale = UI_SCALE
	self.backgroundSprite.x = director.displayWidth * 0.5 - self:getNodeActualWidth(self.backgroundSprite) * 0.5
	self.backgroundSprite.y = director.displayHeight
end

function tutorialsManager:showContextTutorial(tutorialId)
	--dbg.print("CONTEXT TUTORIAL >>>>>>>>>>>>>>>>>>>>>> tutorialsManager:showContextTutorial tutorial id " ..tutorialId)-- .. " str " ..self.availableTutorialsTable[tutorialId])
	--self:initializeGraphics()
	self.tutorialTextLabel.text = getString(self.availableTutorialsTable[tutorialId])
	
	self.animation_pos_y 			= self.backgroundSprite.y
	self.animation_vel_y			= 0
	self.startY						= self.backgroundSprite.y
	self.goalY						= director.displayHeight - self:getNodeActualHeight(self.backgroundSprite) 
	self:changeState(tutorialsManager.INBOUND_ANIMATION_STATE)
	g_contextTutorialsTable[tutorialId]:activate()
end

function tutorialsManager:showFixedTutorial(tutorialIdString, worldNumber, levelNumber)
	--dbg.print("FIXED TUTORIAL ------------------- tutorialsManager:showFixedTutorial " ..tutorialIdString ..", " ..worldNumber ..", " ..levelNumber)
	--self.currentFixedTutorial = {}
	--self.currentFixedTutorial.tutorialIdString = tutorialIdString
	--self.currentFixedTutorial.worldNumber = worldNumber
	--self.currentFixedTutorial.levelNumber = levelNumber
	if(tonumber(self.performedFixedTutorialsTable[tutorialIdString].worldNumber) <=0 or tonumber(self.performedFixedTutorialsTable[tutorialIdString].levelNumber) <=0) then
		self:addFixedtutorialsToPerformedList(tutorialIdString, worldNumber, levelNumber)		
		self:saveFixedTutorials()
	end
	--self:initializeGraphics()
	
	self.tutorialTextLabel.text = getString(self.availableTutorialsTable[tutorialIdString])
	
	self.animation_pos_y 			= self.backgroundSprite.y
	self.animation_vel_y			= 0
	self.startY						= self.backgroundSprite.y
	self.goalY						= director.displayHeight - self:getNodeActualHeight(self.backgroundSprite) 	
	
	self:changeState(tutorialsManager.INBOUND_ANIMATION_STATE)
end

function tutorialsManager:saveFixedTutorials()
	dbg.print("---------------tutorialsManager:saveFixedTutorials")
	local fileContent = ""
	local sortedLines = {}
	local entriesCount = 0
	for k, v in pairs(self.performedFixedTutorialsTable) do
		sortedLines[tonumber(k)] = v
		entriesCount = entriesCount + 1
	end

	--for k, v in pairs(self.performedFixedTutorialsTable) do
	for i=1, entriesCount do
		--dbg.print("printing a tutorial table")
		--dbg.printTable(v)
		local k = "" ..i
		local v = sortedLines[i]
		local formattedData = self:formatFixedTutorialData(v)
		local formattedId = self:addLeadingZeroes(string.len(tutorialsManager.MAX_TILES_TYPES), k)
		
		fileContent = fileContent ..formattedId .."="..formattedData.worldNumber .."," ..formattedData.levelNumber
		if(i ~= entriesCount )then
			fileContent = fileContent .."\n"
		end
	end
	
	--string.sub(fileContent, 1, string.len(fileContent) -1)
	
	local saveFilePath = "tutorials/performed_fixed_tutorials.txt"
	local file = io.open(saveFilePath, "w")
	if (file ~= nil) then
		dbg.print("===============>>>>>>> Saving performed tutorials to " ..saveFilePath)
		file:write(fileContent)
		file:close()
	else
		dbg.print("!!!!!!!!!!!!!!!ERROR: Unable to open file in write mode. " ..saveFilePath)
		dialogManager:displayOkDialog(getString(S_IAP_DIALOG_TITLE_ERROR), getString(S_ERROR_SAVE_FAILED), getString(S_IAP_BUTTON_CLOSE_LABEL), -10000)--the dialog id is not important here
	end
end


function tutorialsManager:update(event)
	--local dt = system.gameTime - self.timer
	--self.timer = system.gameTime
	local dt = (event.time - self.timer) * 0.001
	self.timer = event.time
		
	local DT_LIMIT = 0.03
	if(dt > DT_LIMIT)then--this is a trick to have the animation show smooth even if slower
		--if the frame rate is too slow only one maximum dt is processed.
		--the remaining amount of time is lost
		--dbg.print("LOW FPS RATE. dt = " ..dt .." setting dt to the limit " ..DT_LIMIT)
		dt = DT_LIMIT
	end
	
	if(self.enabled == true) then
		for k, v in pairs(g_contextTutorialsTable) do
			v:update(dt)
		end
	end
	
	if (self.state == tutorialsManager.IDLE_STATE) then
		
	elseif (self.state == tutorialsManager.INBOUND_ANIMATION_STATE ) then
		local T = 0.05--TODO tune this constant
		--local T = 1.0--TODO tune this constant
		local dt_div_T = dt / T
		if(dt_div_T > 1.0) then 
			dt_div_T = 1.0 
		end
		local oldPos = self.animation_pos_y
		self.animation_pos_y = (1.0 - dt_div_T) * self.animation_pos_y + dt_div_T * self.goalY
		--dbg.print("dt_div_T " ..dt_div_T .. " self.animation_pos_y " ..self.animation_pos_y)
		--TODO clamp to maximum velocity?
		self.backgroundSprite.y = self.animation_pos_y 
		if(math.abs((self.animation_pos_y - oldPos ) / oldPos) < 0.005) then--TODO check this threshold
			self:changeState(tutorialsManager.SHOWING_ANIMATION_STATE)
		end
	elseif (self.state == tutorialsManager.OUTBOUND_ANIMATION_STATE) then
		local T = 0.05
		local acc = tutorialsManager.MAX_SPEED_NO_SCALE * UI_SCALE / T
		self.animation_vel_y = self.animation_vel_y + acc * dt
		--dbg.print("dt " ..dt .. " acc " ..acc .. " self.animation_vel_y " ..self.animation_vel_y )
		--TODO clamp to maximum velocity?
		self.animation_pos_y = self.animation_pos_y + self.animation_vel_y * dt
		--dbg.print("self.animation_pos_y " ..self.animation_pos_y )
		self.backgroundSprite.y = self.animation_pos_y 
		if (self.animation_pos_y > self.startY) then
			--self.closeFlag = false
			self.animation_vel_y = 0
			self.animation_pos_y = self.startY
			self.backgroundSprite.y = self.animation_pos_y 
			--self:automatonSignal(tutorialsManager.AUTOMATON_SIGNAL_ANIMATION_ENDED)
			self:onCurrentTutorialExit()
		else
			
		end
	elseif (self.state == tutorialsManager.SHOWING_ANIMATION_STATE) then
		local T = 0.05--TODO tune this constant
		local dt_div_T = dt / T
		if(dt_div_T > 1) then 
			dt_div_T = 1 
		end
		self.animation_pos_y = (1.0 - dt_div_T) * self.animation_pos_y + dt_div_T * self.goalY
		--TODO clamp to maximum velocity?
		self.backgroundSprite.y = self.animation_pos_y 
		--[[
		if (self.closeFlag == true) then
			self:changeState(tutorialsManager.OUTBOUND_ANIMATION_STATE)
		end
		--]]
	else
		dbg.print("ERROR utorialsManager:update -> unknown state")
	end
end

function tutorialsManager:isSkipButtonTutorialActive()
	local result = false
	if(self:isAContextTutorialActive()) then
		local curTutorial = self:peekTutorialFromStack()
		--dbg.print("curTutorial.id " ..curTutorial.tutorialId )
		--dbg.print("skippingButtonTutorial.id " ..skippingButtonTutorial.id )
		if(curTutorial.tutorialId == skippingButtonTutorial.id)then
			--dbg.print("found skip button tutorial active")
			result = true
		else
			--dbg.print("found skip button tutorial NOT active")
		end
	end
	return result
end

function tutorialsManager:isAContextTutorialActive()
	local result = false
	local curTutorial = self:peekTutorialFromStack()
	if(curTutorial ~= nil)then
		--dbg.print("current tutorial id " ..curTutorial.tutorialId)
		--result = curTutorial.isContextTutorial
		result = true
	end
	return result
end

function tutorialsManager:contextTutorialScheduleAttempt(contextTutorialId)
	--dbg.print(">>>>>>>>>>>>>>>>>> tutorialsManager:contextTutorialScheduleAttempt " ..contextTutorialId)
	if(self.achievedContextTutorialsTable[contextTutorialId] == nil)then
		self:suspendCurrentTutorial()
		self:pushTutorialToStack(contextTutorialId, true, "", "")
		self:printStack()
		if(self.state == tutorialsManager.IDLE_STATE)then
			self:showContextTutorial(contextTutorialId)
		end
	else
		dbg.print("tutorial " ..contextTutorialId .." has been already performed")
	end
end

function tutorialsManager:onCurrentTutorialExit()
	dbg.print("tutorialsManager:onCurrentTutorialExit")
	--dbg.print(dbg.getProcessedCallstack()) 
	if(self.pauseFlag ~= true) then
		--local lastTutorial = self:peekTutorialFromStack()--just for debugging
		dbg.print("on exit close")
		self:printStack()
		self:popTutorialFromStack()
		--dbg.print("popped lastTutorial " ..lastTutorial.tutorialId)
	else
		dbg.print("on exit suspend")
	end
	self:printStack()
	self.pauseFlag = false
	local tutorial = self:peekTutorialFromStack()
	if(tutorial ~= nil)then
		dbg.print("ready to launch tutorial " ..tutorial.tutorialId)
		if(tutorial.isContextTutorial == true) then
			if(self.achievedContextTutorialsTable[tutorial.tutorialId] == nil)then
				--over here
				self:showContextTutorial(tutorial.tutorialId)
			else
				self:onCurrentTutorialExit()--keep going until we empty the stack or we find a not achieved tutorial
			end
		else
			self:showFixedTutorial(tutorial.tutorialId, tutorial.worldNumber, tutorial.levelNumber)
		end
	else
		dbg.print("tutorial stack is empty")
		self:changeState(tutorialsManager.IDLE_STATE)
	end
end

function tutorialsManager:suspendCurrentTutorial()
	dbg.print("tutorialsManager:suspendCurrentTutorial")
	if(self.tutorialsStack ~= nil)then
		--self:printStack()
		if(self.tutorialsStack.isContextTutorial == true) then	
			--self.tutorialsStack:deactivate()
			--if(g_contextTutorialsTable[self.tutorialsStack.tutorialId]:isActive())then
			dbg.print("deactivating tutorial " ..self.tutorialsStack.tutorialId)
			g_contextTutorialsTable[self.tutorialsStack.tutorialId]:deactivate()
			--if (self.state == tutorialsManager.SHOWING_ANIMATION_STATE or self.state == tutorialsManager.INBOUND_ANIMATION_STATE) then
			if (self.state ~= tutorialsManager.IDLE_STATE) then
				self:changeState(tutorialsManager.OUTBOUND_ANIMATION_STATE)	
				self.pauseFlag = true
			end
			
			--end
		else
			dbg.print("current tutorial is fixed tutorial")
			if (self.state ~= tutorialsManager.IDLE_STATE) then
				self:changeState(tutorialsManager.OUTBOUND_ANIMATION_STATE)	
				self.pauseFlag = true
			end
		end
	end
end

function tutorialsManager:closeCurrentTutorial()
	dbg.print("tutorialsManager:closeCurrentTutorial")
	self:changeState(tutorialsManager.OUTBOUND_ANIMATION_STATE)	
	self.pauseFlag = false
	--[[
	if (self.state == tutorialsManager.SHOWING_ANIMATION_STATE or self.state == tutorialsManager.INBOUND_ANIMATION_STATE) then
		self:changeState(tutorialsManager.OUTBOUND_ANIMATION_STATE)		
		self.pauseFlag = false
	elseif(self.state == tutorialsManager.OUTBOUND_ANIMATION_STATE)then
		self.pauseFlag = false
	end
	--]]
end

function tutorialsManager:levelReset()
	self:quitTutorials()
end

function tutorialsManager:quitTutorials()
	--cut the rest of the stack because we will not launch any other tutorial after this call
	self.enabled = false
	for k, v in pairs(g_contextTutorialsTable) do
		v:canceled()
	end
	local tutorial = self:peekTutorialFromStack()
	if(tutorial ~= nil) then
		tutorial.previous = nil
		self:closeCurrentTutorial()
	end
end

function tutorialsManager:levelComplete()
	self.enabled = false
	for k, v in pairs(g_contextTutorialsTable) do
		v:levelComplete()
	end
	self:quitTutorials()
end

-- Allows us to temporarily hide tutorials when the hint purchase pop-up appears
function tutorialsManager:showTutorial(event)
	if self.backgroundSprite ~= nil then
		self.backgroundSprite.isVisible = event.show
	end
end

--[[
function tutorialsManager:computeFiguresnum(number)
	local figuresCount = 0
	--local quot = math.floor(worldNumberValue / 10)
	local quit = false
	while(not quit) do
		figuresCount = figuresCount + 1
		quit = (math.floor(worldNumberValue / 10) == 0)
	end
	return figuresCount 
end

function tutorialsManager:initializeNumberFormatter()
	tutorialsManager.MAX_WORLD_LEVEL_NUM_FIGURES = self:computeFiguresnum(tutorialsManager.MAX_WORLD_LEVEL_NUMBER)
	tutorialsManager.MAX_TILE_TYPES_NUM_FIGURES = self:computeFiguresnum(tutorialsManager.MAX_TILES_TYPES)
end

tutorialsManager:initializeNumberFormatter()
--]]
system:addEventListener("update", tutorialsManager)
system:addEventListener("skipButtonVisible", tutorialsManager)
system:addEventListener("skipButtonInVisible", tutorialsManager)
system:addEventListener("skipCurrentLevel", tutorialsManager)
system:addEventListener("showTutorial", tutorialsManager)
